﻿// CodeGear C++Builder
// Copyright (c) 1995, 2014 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AdvGraphicsTypes.pas' rev: 27.00 (Windows)

#ifndef AdvgraphicstypesHPP
#define AdvgraphicstypesHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Winapi.Windows.hpp>	// Pascal unit
#include <System.Classes.hpp>	// Pascal unit
#include <System.Types.hpp>	// Pascal unit
#include <AdvTypes.hpp>	// Pascal unit
#include <Vcl.Graphics.hpp>	// Pascal unit
#include <System.UITypes.hpp>	// Pascal unit
#include <System.Generics.Collections.hpp>	// Pascal unit
#include <System.SysUtils.hpp>	// Pascal unit
#include <System.Generics.Defaults.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Advgraphicstypes
{
//-- type declarations -------------------------------------------------------
typedef System::Uitypes::TColor TAdvGraphicsColor;

struct DECLSPEC_DRECORD TAdvGraphicsColorEntry
{
public:
	System::Uitypes::TColor Value;
	System::WideChar *Name;
};


enum DECLSPEC_DENUM TAdvGraphicsStrokeKind : unsigned char { gskNone, gskSolid, gskDash, gskDot, gskDashDot, gskDashDotDot };

enum DECLSPEC_DENUM TAdvGraphicsTextureMode : unsigned char { gtmOriginal, gtmFit, gtmStretch, gtmCenter, gtmTile };

enum DECLSPEC_DENUM TAdvGraphicsFillKind : unsigned char { gfkNone, gfkSolid, gfkGradient, gfkTexture };

enum DECLSPEC_DENUM TAdvGraphicsFillOrientation : unsigned char { gfoHorizontal, gfoVertical };

enum DECLSPEC_DENUM TAdvGraphicsTextAlign : unsigned char { gtaCenter, gtaLeading, gtaTrailing };

enum DECLSPEC_DENUM TAdvGraphicsTextTrimming : unsigned char { gttNone, gttCharacter, gttWord };

enum DECLSPEC_DENUM TAdvGraphicsSide : unsigned char { gsLeft, gsTop, gsRight, gsBottom };

typedef System::Set<TAdvGraphicsSide, TAdvGraphicsSide::gsLeft, TAdvGraphicsSide::gsBottom> TAdvGraphicsSides;

enum DECLSPEC_DENUM TAdvGraphicsTextQuality : unsigned char { gtqDefault, gtqAntiAliasing, gtqClearType };

class DELPHICLASS TAdvGraphicsSaveState;
class DELPHICLASS TAdvGraphicsFont;
class DELPHICLASS TAdvGraphicsStroke;
class DELPHICLASS TAdvGraphicsFill;
#pragma pack(push,4)
class PASCALIMPLEMENTATION TAdvGraphicsSaveState : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	int FSaveDC;
	TAdvGraphicsFont* FFont;
	TAdvGraphicsStroke* FStroke;
	TAdvGraphicsFill* FFill;
	int FCustomSaveDC;
	void __fastcall SetStroke(TAdvGraphicsStroke* const Value);
	void __fastcall SetFill(TAdvGraphicsFill* const Value);
	void __fastcall SetFont(TAdvGraphicsFont* const Value);
	
public:
	__fastcall TAdvGraphicsSaveState(void);
	__fastcall virtual ~TAdvGraphicsSaveState(void);
	__property TAdvGraphicsStroke* Stroke = {read=FStroke, write=SetStroke};
	__property TAdvGraphicsFill* Fill = {read=FFill, write=SetFill};
	__property TAdvGraphicsFont* Font = {read=FFont, write=SetFont};
	__property int CustomSaveDC = {read=FCustomSaveDC, write=FCustomSaveDC, nodefault};
	__property int SaveDC = {read=FSaveDC, write=FSaveDC, nodefault};
};

#pragma pack(pop)

class DELPHICLASS TAdvCustomGraphicsFill;
class PASCALIMPLEMENTATION TAdvCustomGraphicsFill : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	int FUpdateCount;
	System::Classes::TNotifyEvent FOnChanged;
	TAdvGraphicsFillOrientation FOrientation;
	TAdvGraphicsFillKind FKind;
	System::Uitypes::TColor FColor;
	System::Uitypes::TColor FColorTo;
	System::Uitypes::TColor FColorMirror;
	System::Uitypes::TColor FColorMirrorTo;
	float FOpacity;
	Vcl::Graphics::TPicture* FTexture;
	TAdvGraphicsTextureMode FTextureMode;
	void __fastcall SetKind(const TAdvGraphicsFillKind Value);
	void __fastcall SetOrientation(const TAdvGraphicsFillOrientation Value);
	void __fastcall SetColor(const System::Uitypes::TColor Value);
	void __fastcall SetColorTo(const System::Uitypes::TColor Value);
	void __fastcall SetColorMirror(const System::Uitypes::TColor Value);
	void __fastcall SetColorMirrorTo(const System::Uitypes::TColor Value);
	void __fastcall SetOpacity(const float Value);
	bool __fastcall IsOpacityStored(void);
	void __fastcall SetTexture(Vcl::Graphics::TPicture* const Value);
	void __fastcall SetTextureMode(const TAdvGraphicsTextureMode Value);
	
protected:
	void __fastcall Changed(void);
	void __fastcall TextureChanged(System::TObject* Sender);
	__property System::Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
	__property TAdvGraphicsFillKind Kind = {read=FKind, write=SetKind, default=1};
	__property TAdvGraphicsFillOrientation Orientation = {read=FOrientation, write=SetOrientation, default=1};
	__property System::Uitypes::TColor Color = {read=FColor, write=SetColor, default=16777215};
	__property System::Uitypes::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=8421504};
	__property System::Uitypes::TColor ColorMirror = {read=FColorMirror, write=SetColorMirror, default=-1};
	__property System::Uitypes::TColor ColorMirrorTo = {read=FColorMirrorTo, write=SetColorMirrorTo, default=-1};
	__property float Opacity = {read=FOpacity, write=SetOpacity, stored=IsOpacityStored};
	__property Vcl::Graphics::TPicture* Texture = {read=FTexture, write=SetTexture};
	__property TAdvGraphicsTextureMode TextureMode = {read=FTextureMode, write=SetTextureMode, default=2};
	
public:
	__fastcall virtual TAdvCustomGraphicsFill(const TAdvGraphicsFillKind AKind, const System::Uitypes::TColor AColor);
	__fastcall virtual ~TAdvCustomGraphicsFill(void);
	virtual void __fastcall Assign(System::Classes::TPersistent* Source);
	virtual void __fastcall BeginUpdate(void);
	virtual void __fastcall EndUpdate(void);
};


class PASCALIMPLEMENTATION TAdvGraphicsFill : public TAdvCustomGraphicsFill
{
	typedef TAdvCustomGraphicsFill inherited;
	
public:
	__property Opacity;
	
__published:
	__property OnChanged;
	__property Kind = {default=1};
	__property Orientation = {default=1};
	__property Color = {default=16777215};
	__property ColorTo = {default=8421504};
	__property ColorMirror = {default=-1};
	__property ColorMirrorTo = {default=-1};
	__property TextureMode = {default=2};
	__property Texture;
public:
	/* TAdvCustomGraphicsFill.Create */ inline __fastcall virtual TAdvGraphicsFill(const TAdvGraphicsFillKind AKind, const System::Uitypes::TColor AColor) : TAdvCustomGraphicsFill(AKind, AColor) { }
	/* TAdvCustomGraphicsFill.Destroy */ inline __fastcall virtual ~TAdvGraphicsFill(void) { }
	
};


class PASCALIMPLEMENTATION TAdvGraphicsFont : public Vcl::Graphics::TFont
{
	typedef Vcl::Graphics::TFont inherited;
	
private:
	int FUpdateCount;
	System::Classes::TNotifyEvent FOnChanged;
	
protected:
	void __fastcall DoChanged(System::TObject* Sender);
	
public:
	__fastcall virtual TAdvGraphicsFont(void);
	virtual void __fastcall Assign(System::Classes::TPersistent* Source);
	virtual void __fastcall AssignSource(System::Classes::TPersistent* Source);
	__property System::Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
	virtual void __fastcall BeginUpdate(void);
	virtual void __fastcall EndUpdate(void);
public:
	/* TFont.Destroy */ inline __fastcall virtual ~TAdvGraphicsFont(void) { }
	
};


class DELPHICLASS TAdvCustomGraphicsStroke;
class PASCALIMPLEMENTATION TAdvCustomGraphicsStroke : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
private:
	int FUpdateCount;
	System::Classes::TNotifyEvent FOnChanged;
	TAdvGraphicsStrokeKind FKind;
	System::Uitypes::TColor FColor;
	float FWidth;
	float FOpacity;
	void __fastcall SetKind(const TAdvGraphicsStrokeKind Value);
	void __fastcall SetColor(const System::Uitypes::TColor Value);
	void __fastcall SetWidth(const float Value);
	void __fastcall SetOpacity(const float Value);
	bool __fastcall IsOpacityStored(void);
	bool __fastcall IsWidthStored(void);
	
protected:
	void __fastcall Changed(void);
	__property System::Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
	__property TAdvGraphicsStrokeKind Kind = {read=FKind, write=SetKind, default=1};
	__property System::Uitypes::TColor Color = {read=FColor, write=SetColor, default=12632256};
	__property float Width = {read=FWidth, write=SetWidth, stored=IsWidthStored};
	__property float Opacity = {read=FOpacity, write=SetOpacity, stored=IsOpacityStored};
	
public:
	__fastcall virtual TAdvCustomGraphicsStroke(const TAdvGraphicsStrokeKind AKind, const System::Uitypes::TColor AColor);
	virtual void __fastcall Assign(System::Classes::TPersistent* Source);
	virtual void __fastcall BeginUpdate(void);
	virtual void __fastcall EndUpdate(void);
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAdvCustomGraphicsStroke(void) { }
	
};


class PASCALIMPLEMENTATION TAdvGraphicsStroke : public TAdvCustomGraphicsStroke
{
	typedef TAdvCustomGraphicsStroke inherited;
	
public:
	__property Opacity;
	
__published:
	__property OnChanged;
	__property Kind = {default=1};
	__property Color = {default=12632256};
	__property Width;
public:
	/* TAdvCustomGraphicsStroke.Create */ inline __fastcall virtual TAdvGraphicsStroke(const TAdvGraphicsStrokeKind AKind, const System::Uitypes::TColor AColor) : TAdvCustomGraphicsStroke(AKind, AColor) { }
	
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAdvGraphicsStroke(void) { }
	
};


typedef System::StaticArray<float, 3> TAdvGraphicsVectorArray;

struct DECLSPEC_DRECORD TAdvGraphicsVector
{
	union
	{
		struct 
		{
			float X;
			float Y;
			float W;
		};
		struct 
		{
			TAdvGraphicsVectorArray V;
		};
		
	};
};


typedef System::StaticArray<TAdvGraphicsVector, 3> TAdvGraphicsMatrixArray;

struct DECLSPEC_DRECORD TAdvGraphicsMatrix
{
private:
	TAdvGraphicsMatrix __fastcall Scale(const float AFactor);
	
public:
	static TAdvGraphicsMatrix __fastcall Identity();
	static TAdvGraphicsMatrix __fastcall CreateRotation(const float AAngle);
	static TAdvGraphicsMatrix __fastcall CreateScaling(const float AScaleX, const float AScaleY);
	static TAdvGraphicsMatrix __fastcall CreateTranslation(const float ADeltaX, const float ADeltaY);
	static TAdvGraphicsMatrix __fastcall _op_Multiply(const TAdvGraphicsMatrix &AMatrix1, const TAdvGraphicsMatrix &AMatrix2);
	static System::Types::TPointF __fastcall _op_Multiply(const System::Types::TPointF &APoint, const TAdvGraphicsMatrix &AMatrix);
	float __fastcall Determinant(void);
	TAdvGraphicsMatrix __fastcall Adjoint(void);
	TAdvGraphicsMatrix __fastcall Inverse(void);
	union
	{
		struct 
		{
			float m11;
			float m12;
			float m13;
			float m21;
			float m22;
			float m23;
			float m31;
			float m32;
			float m33;
		};
		struct 
		{
			TAdvGraphicsMatrixArray M;
		};
		
	};
};


typedef System::DynamicArray<System::Types::TPointF> TAdvGraphicsPathPolygon;

enum DECLSPEC_DENUM TAdvGraphicsPathPointKind : unsigned char { gppMoveTo, gppLineTo, gppCurveTo, gppClose };

typedef System::StaticArray<System::Types::TPointF, 4> TAdvGraphicsPathCubicBezier;

struct DECLSPEC_DRECORD TAdvGraphicsPathPoint
{
public:
	TAdvGraphicsPathPointKind Kind;
	bool Dummy;
	System::Types::TPointF Point;
};


enum DECLSPEC_DENUM TAdvGraphicsPathDrawMode : unsigned char { pdmPolygon, pdmPolyline };

class DELPHICLASS TAdvGraphicsPathPoints;
class PASCALIMPLEMENTATION TAdvGraphicsPathPoints : public System::Generics::Collections::TList__1<TAdvGraphicsPathPoint>
{
	typedef System::Generics::Collections::TList__1<TAdvGraphicsPathPoint> inherited;
	
public:
	/* {System_Generics_Collections}TList<AdvGraphicsTypes_TAdvGraphicsPathPoint>.Create */ inline __fastcall TAdvGraphicsPathPoints(void)/* overload */ : System::Generics::Collections::TList__1<TAdvGraphicsPathPoint>() { }
	/* {System_Generics_Collections}TList<AdvGraphicsTypes_TAdvGraphicsPathPoint>.Create */ inline __fastcall TAdvGraphicsPathPoints(const System::DelphiInterface<System::Generics::Defaults::IComparer__1<TAdvGraphicsPathPoint> > AComparer)/* overload */ : System::Generics::Collections::TList__1<TAdvGraphicsPathPoint>(AComparer) { }
	/* {System_Generics_Collections}TList<AdvGraphicsTypes_TAdvGraphicsPathPoint>.Create */ inline __fastcall TAdvGraphicsPathPoints(System::Generics::Collections::TEnumerable__1<TAdvGraphicsPathPoint>* const Collection)/* overload */ : System::Generics::Collections::TList__1<TAdvGraphicsPathPoint>(Collection) { }
	/* {System_Generics_Collections}TList<AdvGraphicsTypes_TAdvGraphicsPathPoint>.Destroy */ inline __fastcall virtual ~TAdvGraphicsPathPoints(void) { }
	
};


class DELPHICLASS TAdvGraphicsPath;
#pragma pack(push,4)
class PASCALIMPLEMENTATION TAdvGraphicsPath : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
public:
	TAdvGraphicsPathPoint operator[](int AIndex) { return Points[AIndex]; }
	
private:
	System::Types::TPointF FStartPoint;
	bool FClippable;
	TAdvGraphicsPathPoints* FPoints;
	void __fastcall CalculateBezierCoefficients(const TAdvGraphicsPathCubicBezier &Bezier, /* out */ float &AX, /* out */ float &BX, /* out */ float &CX, /* out */ float &AY, /* out */ float &BY, /* out */ float &CY);
	int __fastcall GetCount(void);
	TAdvGraphicsPathPoint __fastcall GetPoint(int AIndex);
	
public:
	__fastcall virtual TAdvGraphicsPath(void);
	__fastcall virtual ~TAdvGraphicsPath(void);
	virtual void __fastcall Assign(System::Classes::TPersistent* Source);
	System::Types::TPointF __fastcall LastPoint(void);
	bool __fastcall IsPointVisible(const System::Types::TPointF &P);
	bool __fastcall IsRectVisible(const System::Types::TRectF &R);
	System::Types::TPointF __fastcall PointOnBezier(const System::Types::TPointF &StartPoint, const float AX, const float BX, const float CX, const float AY, const float BY, const float CY, const float T);
	TAdvGraphicsPathPolygon __fastcall CreateBezier(const TAdvGraphicsPathCubicBezier &Bezier, const int PointCount);
	System::Types::TRectF __fastcall GetBounds(void);
	bool __fastcall IsClippable(void);
	void __fastcall MoveTo(const System::Types::TPointF &P);
	void __fastcall LineTo(const System::Types::TPointF &P);
	void __fastcall CurveTo(const System::Types::TPointF &ControlPoint1, const System::Types::TPointF &ControlPoint2, const System::Types::TPointF &EndPoint);
	void __fastcall SmoothCurveTo(const System::Types::TPointF &ControlPoint2, const System::Types::TPointF &EndPoint);
	void __fastcall QuadCurveTo(const System::Types::TPointF &ControlPoint, const System::Types::TPointF &EndPoint);
	void __fastcall AddPolygon(const TAdvGraphicsPathPolygon APolygon);
	void __fastcall ClosePath(void);
	void __fastcall AddLine(const System::Types::TPointF &StartPoint, const System::Types::TPointF &EndPoint);
	void __fastcall AddEllipse(const System::Types::TRectF &ARect);
	void __fastcall AddRectangle(const System::Types::TRectF &ARect);
	void __fastcall AddArc(const System::Types::TPointF &Center, const System::Types::TPointF &Radius, float StartAngle, float SweepAngle);
	void __fastcall AddPath(TAdvGraphicsPath* APath);
	void __fastcall ApplyMatrix(const TAdvGraphicsMatrix &AMatrix);
	void __fastcall Clear(void);
	void __fastcall Flatten(const float Flatness = 2.500000E-01f);
	void __fastcall FlattenToPolygon(TAdvGraphicsPathPolygon &Polygon, const float Flatness = 2.500000E-01f);
	__property int Count = {read=GetCount, nodefault};
	__property TAdvGraphicsPathPoint Points[int AIndex] = {read=GetPoint/*, default*/};
	__property TAdvGraphicsPathPoints* PathData = {read=FPoints};
	__property bool Clippable = {read=FClippable, write=FClippable, nodefault};
};

#pragma pack(pop)

class DELPHICLASS TAdvGraphicsColorObject;
#pragma pack(push,4)
class PASCALIMPLEMENTATION TAdvGraphicsColorObject : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::Uitypes::TColor FColor;
	
public:
	__fastcall TAdvGraphicsColorObject(System::Uitypes::TColor AColor);
	__property System::Uitypes::TColor Color = {read=FColor, write=FColor, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TAdvGraphicsColorObject(void) { }
	
};

#pragma pack(pop)

enum DECLSPEC_DENUM TAdvGraphicsModifyRectMode : unsigned char { gcrmNone, gcrmExpandAll, gcrmShrinkAll, gcrmShiftRightAndExpandHeight, gcrmShiftDownAndExpandWidth, gcrmShiftRightAndShrinkHeight, gcrmShiftRightDown, gcrmShiftRightUp, gcrmShiftLeftUp, gcrmShiftLeftDown, gcrmShiftUpAndExpandWidth, gcrmShiftLeftAndExpandHeight };

enum DECLSPEC_DENUM TAdvGraphicsModifyPointMode : unsigned char { gcpmNone, gcpmLeftUp, gcpmRightDown, gcpmLeftDown, gcpmRightUp };

enum DECLSPEC_DENUM TAdvGraphicsExpanderState : unsigned char { gesCollapsed, gesExpanded };

enum DECLSPEC_DENUM TAdvGraphicsCompactState : unsigned char { gcsCollapsed, gcsExpanded };

enum DECLSPEC_DENUM TAdvGraphicsCorner : unsigned char { gcTopLeft, gcTopRight, gcBottomLeft, gcBottomRight };

typedef System::Set<TAdvGraphicsCorner, TAdvGraphicsCorner::gcTopLeft, TAdvGraphicsCorner::gcBottomRight> TAdvGraphicsCorners;

//-- var, const, procedure ---------------------------------------------------
static const System::Int8 FPC_FULLVERSION = System::Int8(0x0);
static const System::Extended PathScale = 1.000000E-04;
static const System::Extended PathFontSize = 1.000000E-02;
static const System::Extended PathPosition = 1.000000E-03;
static const System::Extended PathAngle = 1.000000E-04;
static const int gcAliceblue = int(0xfff8f0);
static const int gcAntiquewhite = int(0xd7ebfa);
static const int gcAqua = int(0xffff00);
static const int gcAquamarine = int(0xd4ff7f);
static const int gcAzure = int(0xfffff0);
static const int gcBeige = int(0xdcf5f5);
static const int gcBisque = int(0xc4e4ff);
static const System::Int8 gcBlack = System::Int8(0x0);
static const int gcBlanchedalmond = int(0xcdebff);
static const int gcBlue = int(0xff0000);
static const int gcBlueviolet = int(0xe22b8a);
static const int gcBrown = int(0x2a2aa5);
static const int gcBurlywood = int(0x87b8de);
static const int gcCadetblue = int(0xa09e5f);
static const System::Word gcChartreuse = System::Word(0xff7f);
static const int gcChocolate = int(0x1e69d2);
static const int gcCoral = int(0x507fff);
static const int gcCornflowerblue = int(0xed9564);
static const int gcCornsilk = int(0xdcf8ff);
static const int gcCrimson = int(0x3c14dc);
static const int gcCyan = int(0xffff00);
static const int gcDarkblue = int(0x8b0000);
static const int gcDarkcyan = int(0x8b8b00);
static const int gcDarkgoldenrod = int(0xb86b8);
static const int gcDarkgray = int(0xa9a9a9);
static const System::Word gcDarkgreen = System::Word(0x6400);
static const int gcDarkgrey = int(0xa9a9a9);
static const int gcDarkkhaki = int(0x6bb7bd);
static const int gcDarkmagenta = int(0x8b008b);
static const int gcDarkolivegreen = int(0x2f6b55);
static const System::Word gcDarkorange = System::Word(0x8cff);
static const int gcDarkorchid = int(0xcc3299);
static const System::Byte gcDarkred = System::Byte(0x8b);
static const int gcDarksalmon = int(0x7a96e9);
static const int gcDarkseagreen = int(0x8fbc8f);
static const int gcDarkslateblue = int(0x8b3d48);
static const int gcDarkslategray = int(0x4f4f2f);
static const int gcDarkslategrey = int(0x4f4f2f);
static const int gcDarkturquoise = int(0xd1ce00);
static const int gcDarkviolet = int(0xd30094);
static const int gcDeeppink = int(0x9314ff);
static const int gcDeepskyblue = int(0xffbf00);
static const int gcDimgray = int(0x696969);
static const int gcDimgrey = int(0x696969);
static const int gcDodgerblue = int(0xff901e);
static const int gcFirebrick = int(0x2222b2);
static const int gcFloralwhite = int(0xf0faff);
static const int gcForestgreen = int(0x228b22);
static const int gcFuchsia = int(0xff00ff);
static const int gcGainsboro = int(0xdcdcdc);
static const int gcGhostwhite = int(0xfff8f8);
static const System::Word gcGold = System::Word(0xd7ff);
static const int gcGoldenrod = int(0x20a5da);
static const int gcGray = int(0x808080);
static const System::Word gcGreen = System::Word(0x8000);
static const int gcGreenyellow = int(0x2fffad);
static const int gcGrey = int(0x808080);
static const int gcHoneydew = int(0xf0fff0);
static const int gcHotpink = int(0xb469ff);
static const int gcIndianred = int(0x5c5ccd);
static const int gcIndigo = int(0x82004b);
static const int gcIvory = int(0xf0ffff);
static const int gcKhaki = int(0x8ce6f0);
static const int gcLavender = int(0xfae6e6);
static const int gcLavenderblush = int(0xf5f0ff);
static const System::Word gcLawngreen = System::Word(0xfc7c);
static const int gcLemonchiffon = int(0xcdfaff);
static const int gcLightblue = int(0xe6d8ad);
static const int gcLightcoral = int(0x8080f0);
static const int gcLightcyan = int(0xffffe0);
static const int gcLightgoldenrodyellow = int(0xd2fafa);
static const int gcLightgray = int(0xd3d3d3);
static const int gcLightgreen = int(0x90ee90);
static const int gcLightgrey = int(0xd3d3d3);
static const int gcLightpink = int(0xc1b6ff);
static const int gcLightsalmon = int(0x7aa0ff);
static const int gcLightseagreen = int(0xaab220);
static const int gcLightskyblue = int(0xface87);
static const int gcLightslategray = int(0x998877);
static const int gcLightslategrey = int(0x998877);
static const int gcLightsteelblue = int(0xdec4b0);
static const int gcLightyellow = int(0xe0ffff);
static const int gcLtGray = int(0xc0c0c0);
static const int gcMedGray = int(0xa4a0a0);
static const int gcDkGray = int(0x808080);
static const int gcMoneyGreen = int(0xc0dcc0);
static const int gcLegacySkyBlue = int(0xf0caa6);
static const int gcCream = int(0xf0fbff);
static const System::Word gcLime = System::Word(0xff00);
static const int gcLimegreen = int(0x32cd32);
static const int gcLinen = int(0xe6f0fa);
static const int gcMagenta = int(0xff00ff);
static const System::Byte gcMaroon = System::Byte(0x80);
static const int gcMediumaquamarine = int(0xaacd66);
static const int gcMediumblue = int(0xcd0000);
static const int gcMediumorchid = int(0xd355ba);
static const int gcMediumpurple = int(0xdb7093);
static const int gcMediumseagreen = int(0x71b33c);
static const int gcMediumslateblue = int(0xee687b);
static const int gcMediumspringgreen = int(0x9afa00);
static const int gcMediumturquoise = int(0xccd148);
static const int gcMediumvioletred = int(0x8515c7);
static const int gcMidnightblue = int(0x701919);
static const int gcMintcream = int(0xfafff5);
static const int gcMistyrose = int(0xe1e4ff);
static const int gcMoccasin = int(0xb5e4ff);
static const int gcNavajowhite = int(0xaddeff);
static const int gcNavy = int(0x800000);
static const int gcOldlace = int(0xe6f5fd);
static const System::Word gcOlive = System::Word(0x8080);
static const int gcOlivedrab = int(0x238e6b);
static const System::Word gcOrange = System::Word(0xa5ff);
static const System::Word gcOrangered = System::Word(0x45ff);
static const int gcOrchid = int(0xd670da);
static const int gcPalegoldenrod = int(0xaae8ee);
static const int gcPalegreen = int(0x98fb98);
static const int gcPaleturquoise = int(0xeeeeaf);
static const int gcPalevioletred = int(0x9370db);
static const int gcPapayawhip = int(0xd5efff);
static const int gcPeachpuff = int(0xb9daff);
static const int gcPeru = int(0x3f85cd);
static const int gcPink = int(0xcbc0ff);
static const int gcPlum = int(0xdda0dd);
static const int gcPowderblue = int(0xe6e0b0);
static const int gcPurple = int(0x800080);
static const System::Byte gcRed = System::Byte(0xff);
static const int gcRosybrown = int(0x8f8fbc);
static const int gcRoyalblue = int(0xe16941);
static const int gcSaddlebrown = int(0x13458b);
static const int gcSalmon = int(0x7280fa);
static const int gcSandybrown = int(0x60a4f4);
static const int gcSeagreen = int(0x578b2e);
static const int gcSeashell = int(0xeef5ff);
static const int gcSienna = int(0x2d52a0);
static const int gcSilver = int(0xc0c0c0);
static const int gcSkyblue = int(0xebce87);
static const int gcSlateblue = int(0xcd5a6a);
static const int gcSlategray = int(0x908070);
static const int gcSlategrey = int(0x908070);
static const int gcSnow = int(0xfafaff);
static const int gcSpringgreen = int(0x7fff00);
static const int gcSteelblue = int(0xb48246);
static const int gcTan = int(0x8cb4d2);
static const int gcTeal = int(0x808000);
static const int gcThistle = int(0xd8bfd8);
static const int gcTomato = int(0x4763ff);
static const int gcTurquoise = int(0xd0e040);
static const int gcViolet = int(0xee82ee);
static const int gcWheat = int(0xb3def5);
static const int gcWhite = int(0xffffff);
static const int gcWhitesmoke = int(0xf5f5f5);
static const System::Word gcYellow = System::Word(0xffff);
static const int gcYellowgreen = int(0x32cd9a);
static const System::Int8 gcNull = System::Int8(-1);
static const System::Byte AdvGraphicsColorCount = System::Byte(0x9a);
extern DELPHI_PACKAGE System::StaticArray<TAdvGraphicsColorEntry, 154> AdvGraphicsColors;
#define AllSides (System::Set<TAdvGraphicsSide, TAdvGraphicsSide::gsLeft, TAdvGraphicsSide::gsBottom>() << TAdvGraphicsSide::gsLeft << TAdvGraphicsSide::gsTop << TAdvGraphicsSide::gsRight << TAdvGraphicsSide::gsBottom )
extern DELPHI_PACKAGE float Epsilon;
extern DELPHI_PACKAGE System::Types::TRectF __fastcall ModifyRect(const System::Types::TRectF &ARect, const TAdvGraphicsModifyRectMode ARectMode);
extern DELPHI_PACKAGE System::Types::TPointF __fastcall ModifyPoint(const System::Types::TPointF &APoint, const TAdvGraphicsModifyPointMode APointMode);
extern DELPHI_PACKAGE System::Classes::TStringList* __fastcall ColorLookup(void);
extern DELPHI_PACKAGE bool __fastcall PolyInRect(TAdvGraphicsPathPolygon APolygon, const System::Types::TRectF &ARect);
extern DELPHI_PACKAGE bool __fastcall RectInPoly(const System::Types::TRectF &ARect, TAdvGraphicsPathPolygon APolygon);
extern DELPHI_PACKAGE bool __fastcall PointInPoly(const System::Types::TPointF &APoint, TAdvGraphicsPathPolygon APolygon);
extern DELPHI_PACKAGE System::Uitypes::TColor __fastcall Blend(System::Uitypes::TColor AColor1, System::Uitypes::TColor AColor2, System::Byte ALevel);
extern DELPHI_PACKAGE System::Uitypes::TColor __fastcall Lighter(System::Uitypes::TColor AColor, System::Byte APercent);
extern DELPHI_PACKAGE System::Uitypes::TColor __fastcall Darker(System::Uitypes::TColor AColor, System::Byte APercent);
extern DELPHI_PACKAGE void __fastcall DrawGradient(Vcl::Graphics::TCanvas* ACanvas, System::Uitypes::TColor AColor, System::Uitypes::TColor AColorTo, const System::Types::TRect &ARect, float ARounding, TAdvGraphicsCorners ACorners, bool ADirection);
extern DELPHI_PACKAGE System::Uitypes::TColor __fastcall MakeGraphicsColor(System::Byte ARed, System::Byte AGreen, System::Byte ABlue);
}	/* namespace Advgraphicstypes */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_ADVGRAPHICSTYPES)
using namespace Advgraphicstypes;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AdvgraphicstypesHPP
