// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AdvGraphicsTypes.pas' rev: 22.00

#ifndef AdvgraphicstypesHPP
#define AdvgraphicstypesHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit
#include <AdvTypes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Generics.Collections.hpp>	// Pascal unit
#include <Generics.Defaults.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Advgraphicstypes
{
//-- type declarations -------------------------------------------------------
typedef Graphics::TColor TAdvGraphicsColor;

struct DECLSPEC_DRECORD TAdvGraphicsColorEntry
{
	
public:
	Graphics::TColor Value;
	System::WideChar *Name;
};


#pragma option push -b-
enum TAdvGraphicsStrokeKind { gskNone, gskSolid, gskDash, gskDot, gskDashDot, gskDashDotDot };
#pragma option pop

#pragma option push -b-
enum TAdvGraphicsTextureMode { gtmOriginal, gtmFit, gtmStretch, gtmCenter, gtmTile };
#pragma option pop

#pragma option push -b-
enum TAdvGraphicsFillKind { gfkNone, gfkSolid, gfkGradient, gfkTexture };
#pragma option pop

#pragma option push -b-
enum TAdvGraphicsFillOrientation { gfoHorizontal, gfoVertical };
#pragma option pop

#pragma option push -b-
enum TAdvGraphicsTextAlign { gtaCenter, gtaLeading, gtaTrailing };
#pragma option pop

#pragma option push -b-
enum TAdvGraphicsTextTrimming { gttNone, gttCharacter, gttWord };
#pragma option pop

#pragma option push -b-
enum TAdvGraphicsSide { gsLeft, gsTop, gsRight, gsBottom };
#pragma option pop

typedef System::Set<TAdvGraphicsSide, TAdvGraphicsSide::gsLeft, TAdvGraphicsSide::gsBottom>  TAdvGraphicsSides;

#pragma option push -b-
enum TAdvGraphicsTextQuality { gtqDefault, gtqAntiAliasing, gtqClearType };
#pragma option pop

class DELPHICLASS TAdvGraphicsSaveState;
class DELPHICLASS TAdvGraphicsFont;
class DELPHICLASS TAdvGraphicsStroke;
class DELPHICLASS TAdvGraphicsFill;
class PASCALIMPLEMENTATION TAdvGraphicsSaveState : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	int FSaveDC;
	TAdvGraphicsFont* FFont;
	TAdvGraphicsStroke* FStroke;
	TAdvGraphicsFill* FFill;
	int FCustomSaveDC;
	void __fastcall SetStroke(const TAdvGraphicsStroke* Value);
	void __fastcall SetFill(const TAdvGraphicsFill* Value);
	void __fastcall SetFont(const TAdvGraphicsFont* Value);
	
public:
	__fastcall TAdvGraphicsSaveState(void);
	__fastcall virtual ~TAdvGraphicsSaveState(void);
	__property TAdvGraphicsStroke* Stroke = {read=FStroke, write=SetStroke};
	__property TAdvGraphicsFill* Fill = {read=FFill, write=SetFill};
	__property TAdvGraphicsFont* Font = {read=FFont, write=SetFont};
	__property int CustomSaveDC = {read=FCustomSaveDC, write=FCustomSaveDC, nodefault};
	__property int SaveDC = {read=FSaveDC, write=FSaveDC, nodefault};
};


class DELPHICLASS TAdvCustomGraphicsFill;
class PASCALIMPLEMENTATION TAdvCustomGraphicsFill : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	int FUpdateCount;
	Classes::TNotifyEvent FOnChanged;
	TAdvGraphicsFillOrientation FOrientation;
	TAdvGraphicsFillKind FKind;
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	Graphics::TColor FColorMirror;
	Graphics::TColor FColorMirrorTo;
	float FOpacity;
	Graphics::TPicture* FTexture;
	TAdvGraphicsTextureMode FTextureMode;
	void __fastcall SetKind(const TAdvGraphicsFillKind Value);
	void __fastcall SetOrientation(const TAdvGraphicsFillOrientation Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	void __fastcall SetColorMirror(const Graphics::TColor Value);
	void __fastcall SetColorMirrorTo(const Graphics::TColor Value);
	void __fastcall SetOpacity(const float Value);
	bool __fastcall IsOpacityStored(void);
	void __fastcall SetTexture(const Graphics::TPicture* Value);
	void __fastcall SetTextureMode(const TAdvGraphicsTextureMode Value);
	
protected:
	void __fastcall Changed(void);
	void __fastcall TextureChanged(System::TObject* Sender);
	__property Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
	__property TAdvGraphicsFillKind Kind = {read=FKind, write=SetKind, default=1};
	__property TAdvGraphicsFillOrientation Orientation = {read=FOrientation, write=SetOrientation, default=1};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=16777215};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=8421504};
	__property Graphics::TColor ColorMirror = {read=FColorMirror, write=SetColorMirror, default=-1};
	__property Graphics::TColor ColorMirrorTo = {read=FColorMirrorTo, write=SetColorMirrorTo, default=-1};
	__property float Opacity = {read=FOpacity, write=SetOpacity, stored=IsOpacityStored};
	__property Graphics::TPicture* Texture = {read=FTexture, write=SetTexture};
	__property TAdvGraphicsTextureMode TextureMode = {read=FTextureMode, write=SetTextureMode, default=2};
	
public:
	__fastcall virtual TAdvCustomGraphicsFill(const TAdvGraphicsFillKind AKind, const Graphics::TColor AColor);
	__fastcall virtual ~TAdvCustomGraphicsFill(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall BeginUpdate(void);
	virtual void __fastcall EndUpdate(void);
};


class PASCALIMPLEMENTATION TAdvGraphicsFill : public TAdvCustomGraphicsFill
{
	typedef TAdvCustomGraphicsFill inherited;
	
public:
	__property Opacity;
	
__published:
	__property OnChanged;
	__property Kind = {default=1};
	__property Orientation = {default=1};
	__property Color = {default=16777215};
	__property ColorTo = {default=8421504};
	__property ColorMirror = {default=-1};
	__property ColorMirrorTo = {default=-1};
	__property TextureMode = {default=2};
	__property Texture;
public:
	/* TAdvCustomGraphicsFill.Create */ inline __fastcall virtual TAdvGraphicsFill(const TAdvGraphicsFillKind AKind, const Graphics::TColor AColor) : TAdvCustomGraphicsFill(AKind, AColor) { }
	/* TAdvCustomGraphicsFill.Destroy */ inline __fastcall virtual ~TAdvGraphicsFill(void) { }
	
};


class PASCALIMPLEMENTATION TAdvGraphicsFont : public Graphics::TFont
{
	typedef Graphics::TFont inherited;
	
private:
	int FUpdateCount;
	Classes::TNotifyEvent FOnChanged;
	
protected:
	void __fastcall DoChanged(System::TObject* Sender);
	
public:
	__fastcall virtual TAdvGraphicsFont(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall AssignSource(Classes::TPersistent* Source);
	__property Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
	virtual void __fastcall BeginUpdate(void);
	virtual void __fastcall EndUpdate(void);
public:
	/* TFont.Destroy */ inline __fastcall virtual ~TAdvGraphicsFont(void) { }
	
};


class DELPHICLASS TAdvCustomGraphicsStroke;
class PASCALIMPLEMENTATION TAdvCustomGraphicsStroke : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	int FUpdateCount;
	Classes::TNotifyEvent FOnChanged;
	TAdvGraphicsStrokeKind FKind;
	Graphics::TColor FColor;
	float FWidth;
	float FOpacity;
	void __fastcall SetKind(const TAdvGraphicsStrokeKind Value);
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetWidth(const float Value);
	void __fastcall SetOpacity(const float Value);
	bool __fastcall IsOpacityStored(void);
	bool __fastcall IsWidthStored(void);
	
protected:
	void __fastcall Changed(void);
	__property Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
	__property TAdvGraphicsStrokeKind Kind = {read=FKind, write=SetKind, default=1};
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=12632256};
	__property float Width = {read=FWidth, write=SetWidth, stored=IsWidthStored};
	__property float Opacity = {read=FOpacity, write=SetOpacity, stored=IsOpacityStored};
	
public:
	__fastcall virtual TAdvCustomGraphicsStroke(const TAdvGraphicsStrokeKind AKind, const Graphics::TColor AColor);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall BeginUpdate(void);
	virtual void __fastcall EndUpdate(void);
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAdvCustomGraphicsStroke(void) { }
	
};


class PASCALIMPLEMENTATION TAdvGraphicsStroke : public TAdvCustomGraphicsStroke
{
	typedef TAdvCustomGraphicsStroke inherited;
	
public:
	__property Opacity;
	
__published:
	__property OnChanged;
	__property Kind = {default=1};
	__property Color = {default=12632256};
	__property Width;
public:
	/* TAdvCustomGraphicsStroke.Create */ inline __fastcall virtual TAdvGraphicsStroke(const TAdvGraphicsStrokeKind AKind, const Graphics::TColor AColor) : TAdvCustomGraphicsStroke(AKind, AColor) { }
	
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAdvGraphicsStroke(void) { }
	
};


typedef System::StaticArray<float, 3> TAdvGraphicsVectorArray;

struct DECLSPEC_DRECORD TAdvGraphicsVector
{
	
	#pragma pack(push,1)
	union
	{
		struct 
		{
			float X;
			float Y;
			float W;
			
		};
		struct 
		{
			TAdvGraphicsVectorArray V;
			
		};
		
	};
	#pragma pack(pop)
};


typedef System::StaticArray<TAdvGraphicsVector, 3> TAdvGraphicsMatrixArray;

struct TAdvGraphicsMatrix;
struct DECLSPEC_DRECORD TAdvGraphicsMatrix
{
	
private:
	TAdvGraphicsMatrix __fastcall Scale(const float AFactor);
	
public:
	static TAdvGraphicsMatrix __fastcall Identity();
	static TAdvGraphicsMatrix __fastcall CreateRotation(const float AAngle);
	static TAdvGraphicsMatrix __fastcall CreateScaling(const float AScaleX, const float AScaleY);
	static TAdvGraphicsMatrix __fastcall CreateTranslation(const float ADeltaX, const float ADeltaY);
	static TAdvGraphicsMatrix __fastcall _op_Multiply(const TAdvGraphicsMatrix &AMatrix1, const TAdvGraphicsMatrix &AMatrix2);
	static Advtypes::TPointF __fastcall _op_Multiply(const Advtypes::TPointF &APoint, const TAdvGraphicsMatrix &AMatrix);
	float __fastcall Determinant(void);
	TAdvGraphicsMatrix __fastcall Adjoint(void);
	TAdvGraphicsMatrix __fastcall Inverse(void);
	#pragma pack(push,1)
	union
	{
		struct 
		{
			float m11;
			float m12;
			float m13;
			float m21;
			float m22;
			float m23;
			float m31;
			float m32;
			float m33;
			
		};
		struct 
		{
			TAdvGraphicsMatrixArray M;
			
		};
		
	};
	#pragma pack(pop)
};


typedef System::DynamicArray<Advtypes::TPointF> TAdvGraphicsPathPolygon;

#pragma option push -b-
enum TAdvGraphicsPathPointKind { gppMoveTo, gppLineTo, gppCurveTo, gppClose };
#pragma option pop

typedef System::StaticArray<Advtypes::TPointF, 4> TAdvGraphicsPathCubicBezier;

struct DECLSPEC_DRECORD TAdvGraphicsPathPoint
{
	
public:
	TAdvGraphicsPathPointKind Kind;
	bool Dummy;
	Advtypes::TPointF Point;
};


#pragma option push -b-
enum TAdvGraphicsPathDrawMode { pdmPolygon, pdmPolyline };
#pragma option pop

class DELPHICLASS TAdvGraphicsPathPoints;
class PASCALIMPLEMENTATION TAdvGraphicsPathPoints : public Generics_collections::TList__1<TAdvGraphicsPathPoint>
{
	typedef Generics_collections::TList__1<TAdvGraphicsPathPoint> inherited;
	
public:
	/* {Generics_Collections}TList<AdvGraphicsTypes_TAdvGraphicsPathPoint>.Create */ inline __fastcall TAdvGraphicsPathPoints(void)/* overload */ : Generics_collections::TList__1<TAdvGraphicsPathPoint>() { }
	/* {Generics_Collections}TList<AdvGraphicsTypes_TAdvGraphicsPathPoint>.Destroy */ inline __fastcall virtual ~TAdvGraphicsPathPoints(void) { }
	
};


class DELPHICLASS TAdvGraphicsPath;
class PASCALIMPLEMENTATION TAdvGraphicsPath : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
public:
	TAdvGraphicsPathPoint operator[](int AIndex) { return Points[AIndex]; }
	
private:
	Advtypes::TPointF FStartPoint;
	bool FClippable;
	TAdvGraphicsPathPoints* FPoints;
	void __fastcall CalculateBezierCoefficients(Advtypes::TPointF const *Bezier, /* out */ float &AX, /* out */ float &BX, /* out */ float &CX, /* out */ float &AY, /* out */ float &BY, /* out */ float &CY);
	int __fastcall GetCount(void);
	TAdvGraphicsPathPoint __fastcall GetPoint(int AIndex);
	
public:
	__fastcall virtual TAdvGraphicsPath(void);
	__fastcall virtual ~TAdvGraphicsPath(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	Advtypes::TPointF __fastcall LastPoint(void);
	bool __fastcall IsPointVisible(const Advtypes::TPointF &P);
	bool __fastcall IsRectVisible(const Advtypes::TRectF &R);
	Advtypes::TPointF __fastcall PointOnBezier(const Advtypes::TPointF &StartPoint, const float AX, const float BX, const float CX, const float AY, const float BY, const float CY, const float T);
	TAdvGraphicsPathPolygon __fastcall CreateBezier(Advtypes::TPointF const *Bezier, const int PointCount);
	Advtypes::TRectF __fastcall GetBounds(void);
	bool __fastcall IsClippable(void);
	void __fastcall MoveTo(const Advtypes::TPointF &P);
	void __fastcall LineTo(const Advtypes::TPointF &P);
	void __fastcall CurveTo(const Advtypes::TPointF &ControlPoint1, const Advtypes::TPointF &ControlPoint2, const Advtypes::TPointF &EndPoint);
	void __fastcall SmoothCurveTo(const Advtypes::TPointF &ControlPoint2, const Advtypes::TPointF &EndPoint);
	void __fastcall QuadCurveTo(const Advtypes::TPointF &ControlPoint, const Advtypes::TPointF &EndPoint);
	void __fastcall AddPolygon(const TAdvGraphicsPathPolygon APolygon);
	void __fastcall ClosePath(void);
	void __fastcall AddLine(const Advtypes::TPointF &StartPoint, const Advtypes::TPointF &EndPoint);
	void __fastcall AddEllipse(const Advtypes::TRectF &ARect);
	void __fastcall AddRectangle(const Advtypes::TRectF &ARect);
	void __fastcall AddArc(const Advtypes::TPointF &Center, const Advtypes::TPointF &Radius, float StartAngle, float SweepAngle);
	void __fastcall AddPath(TAdvGraphicsPath* APath);
	void __fastcall ApplyMatrix(const TAdvGraphicsMatrix &AMatrix);
	void __fastcall Clear(void);
	void __fastcall Flatten(const float Flatness = 2.500000E-01);
	void __fastcall FlattenToPolygon(TAdvGraphicsPathPolygon &Polygon, const float Flatness = 2.500000E-01);
	__property int Count = {read=GetCount, nodefault};
	__property TAdvGraphicsPathPoint Points[int AIndex] = {read=GetPoint/*, default*/};
	__property TAdvGraphicsPathPoints* PathData = {read=FPoints};
	__property bool Clippable = {read=FClippable, write=FClippable, nodefault};
};


class DELPHICLASS TAdvGraphicsColorObject;
class PASCALIMPLEMENTATION TAdvGraphicsColorObject : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	Graphics::TColor FColor;
	
public:
	__fastcall TAdvGraphicsColorObject(Graphics::TColor AColor);
	__property Graphics::TColor Color = {read=FColor, write=FColor, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TAdvGraphicsColorObject(void) { }
	
};


#pragma option push -b-
enum TAdvGraphicsModifyRectMode { gcrmNone, gcrmExpandAll, gcrmShrinkAll, gcrmShiftRightAndExpandHeight, gcrmShiftDownAndExpandWidth, gcrmShiftRightAndShrinkHeight, gcrmShiftRightDown, gcrmShiftRightUp, gcrmShiftLeftUp, gcrmShiftLeftDown, gcrmShiftUpAndExpandWidth, gcrmShiftLeftAndExpandHeight };
#pragma option pop

#pragma option push -b-
enum TAdvGraphicsModifyPointMode { gcpmNone, gcpmLeftUp, gcpmRightDown, gcpmLeftDown, gcpmRightUp };
#pragma option pop

#pragma option push -b-
enum TAdvGraphicsExpanderState { gesCollapsed, gesExpanded };
#pragma option pop

#pragma option push -b-
enum TAdvGraphicsCompactState { gcsCollapsed, gcsExpanded };
#pragma option pop

#pragma option push -b-
enum TAdvGraphicsCorner { gcTopLeft, gcTopRight, gcBottomLeft, gcBottomRight };
#pragma option pop

typedef System::Set<TAdvGraphicsCorner, TAdvGraphicsCorner::gcTopLeft, TAdvGraphicsCorner::gcBottomRight>  TAdvGraphicsCorners;

//-- var, const, procedure ---------------------------------------------------
static const System::ShortInt FPC_FULLVERSION = 0x0;
static const System::Extended PathScale = 1.000000E-04;
static const System::Extended PathFontSize = 1.000000E-02;
static const System::Extended PathPosition = 1.000000E-03;
static const System::Extended PathAngle = 1.000000E-04;
static const int gcAliceblue = 0xfff8f0;
static const int gcAntiquewhite = 0xd7ebfa;
static const int gcAqua = 0xffff00;
static const int gcAquamarine = 0xd4ff7f;
static const int gcAzure = 0xfffff0;
static const int gcBeige = 0xdcf5f5;
static const int gcBisque = 0xc4e4ff;
static const System::ShortInt gcBlack = 0x0;
static const int gcBlanchedalmond = 0xcdebff;
static const int gcBlue = 0xff0000;
static const int gcBlueviolet = 0xe22b8a;
static const int gcBrown = 0x2a2aa5;
static const int gcBurlywood = 0x87b8de;
static const int gcCadetblue = 0xa09e5f;
static const System::Word gcChartreuse = 0xff7f;
static const int gcChocolate = 0x1e69d2;
static const int gcCoral = 0x507fff;
static const int gcCornflowerblue = 0xed9564;
static const int gcCornsilk = 0xdcf8ff;
static const int gcCrimson = 0x3c14dc;
static const int gcCyan = 0xffff00;
static const int gcDarkblue = 0x8b0000;
static const int gcDarkcyan = 0x8b8b00;
static const int gcDarkgoldenrod = 0xb86b8;
static const int gcDarkgray = 0xa9a9a9;
static const System::Word gcDarkgreen = 0x6400;
static const int gcDarkgrey = 0xa9a9a9;
static const int gcDarkkhaki = 0x6bb7bd;
static const int gcDarkmagenta = 0x8b008b;
static const int gcDarkolivegreen = 0x2f6b55;
static const System::Word gcDarkorange = 0x8cff;
static const int gcDarkorchid = 0xcc3299;
static const System::Byte gcDarkred = 0x8b;
static const int gcDarksalmon = 0x7a96e9;
static const int gcDarkseagreen = 0x8fbc8f;
static const int gcDarkslateblue = 0x8b3d48;
static const int gcDarkslategray = 0x4f4f2f;
static const int gcDarkslategrey = 0x4f4f2f;
static const int gcDarkturquoise = 0xd1ce00;
static const int gcDarkviolet = 0xd30094;
static const int gcDeeppink = 0x9314ff;
static const int gcDeepskyblue = 0xffbf00;
static const int gcDimgray = 0x696969;
static const int gcDimgrey = 0x696969;
static const int gcDodgerblue = 0xff901e;
static const int gcFirebrick = 0x2222b2;
static const int gcFloralwhite = 0xf0faff;
static const int gcForestgreen = 0x228b22;
static const int gcFuchsia = 0xff00ff;
static const int gcGainsboro = 0xdcdcdc;
static const int gcGhostwhite = 0xfff8f8;
static const System::Word gcGold = 0xd7ff;
static const int gcGoldenrod = 0x20a5da;
static const int gcGray = 0x808080;
static const System::Word gcGreen = 0x8000;
static const int gcGreenyellow = 0x2fffad;
static const int gcGrey = 0x808080;
static const int gcHoneydew = 0xf0fff0;
static const int gcHotpink = 0xb469ff;
static const int gcIndianred = 0x5c5ccd;
static const int gcIndigo = 0x82004b;
static const int gcIvory = 0xf0ffff;
static const int gcKhaki = 0x8ce6f0;
static const int gcLavender = 0xfae6e6;
static const int gcLavenderblush = 0xf5f0ff;
static const System::Word gcLawngreen = 0xfc7c;
static const int gcLemonchiffon = 0xcdfaff;
static const int gcLightblue = 0xe6d8ad;
static const int gcLightcoral = 0x8080f0;
static const int gcLightcyan = 0xffffe0;
static const int gcLightgoldenrodyellow = 0xd2fafa;
static const int gcLightgray = 0xd3d3d3;
static const int gcLightgreen = 0x90ee90;
static const int gcLightgrey = 0xd3d3d3;
static const int gcLightpink = 0xc1b6ff;
static const int gcLightsalmon = 0x7aa0ff;
static const int gcLightseagreen = 0xaab220;
static const int gcLightskyblue = 0xface87;
static const int gcLightslategray = 0x998877;
static const int gcLightslategrey = 0x998877;
static const int gcLightsteelblue = 0xdec4b0;
static const int gcLightyellow = 0xe0ffff;
static const int gcLtGray = 0xc0c0c0;
static const int gcMedGray = 0xa4a0a0;
static const int gcDkGray = 0x808080;
static const int gcMoneyGreen = 0xc0dcc0;
static const int gcLegacySkyBlue = 0xf0caa6;
static const int gcCream = 0xf0fbff;
static const System::Word gcLime = 0xff00;
static const int gcLimegreen = 0x32cd32;
static const int gcLinen = 0xe6f0fa;
static const int gcMagenta = 0xff00ff;
static const System::Byte gcMaroon = 0x80;
static const int gcMediumaquamarine = 0xaacd66;
static const int gcMediumblue = 0xcd0000;
static const int gcMediumorchid = 0xd355ba;
static const int gcMediumpurple = 0xdb7093;
static const int gcMediumseagreen = 0x71b33c;
static const int gcMediumslateblue = 0xee687b;
static const int gcMediumspringgreen = 0x9afa00;
static const int gcMediumturquoise = 0xccd148;
static const int gcMediumvioletred = 0x8515c7;
static const int gcMidnightblue = 0x701919;
static const int gcMintcream = 0xfafff5;
static const int gcMistyrose = 0xe1e4ff;
static const int gcMoccasin = 0xb5e4ff;
static const int gcNavajowhite = 0xaddeff;
static const int gcNavy = 0x800000;
static const int gcOldlace = 0xe6f5fd;
static const System::Word gcOlive = 0x8080;
static const int gcOlivedrab = 0x238e6b;
static const System::Word gcOrange = 0xa5ff;
static const System::Word gcOrangered = 0x45ff;
static const int gcOrchid = 0xd670da;
static const int gcPalegoldenrod = 0xaae8ee;
static const int gcPalegreen = 0x98fb98;
static const int gcPaleturquoise = 0xeeeeaf;
static const int gcPalevioletred = 0x9370db;
static const int gcPapayawhip = 0xd5efff;
static const int gcPeachpuff = 0xb9daff;
static const int gcPeru = 0x3f85cd;
static const int gcPink = 0xcbc0ff;
static const int gcPlum = 0xdda0dd;
static const int gcPowderblue = 0xe6e0b0;
static const int gcPurple = 0x800080;
static const System::Byte gcRed = 0xff;
static const int gcRosybrown = 0x8f8fbc;
static const int gcRoyalblue = 0xe16941;
static const int gcSaddlebrown = 0x13458b;
static const int gcSalmon = 0x7280fa;
static const int gcSandybrown = 0x60a4f4;
static const int gcSeagreen = 0x578b2e;
static const int gcSeashell = 0xeef5ff;
static const int gcSienna = 0x2d52a0;
static const int gcSilver = 0xc0c0c0;
static const int gcSkyblue = 0xebce87;
static const int gcSlateblue = 0xcd5a6a;
static const int gcSlategray = 0x908070;
static const int gcSlategrey = 0x908070;
static const int gcSnow = 0xfafaff;
static const int gcSpringgreen = 0x7fff00;
static const int gcSteelblue = 0xb48246;
static const int gcTan = 0x8cb4d2;
static const int gcTeal = 0x808000;
static const int gcThistle = 0xd8bfd8;
static const int gcTomato = 0x4763ff;
static const int gcTurquoise = 0xd0e040;
static const int gcViolet = 0xee82ee;
static const int gcWheat = 0xb3def5;
static const int gcWhite = 0xffffff;
static const int gcWhitesmoke = 0xf5f5f5;
static const System::Word gcYellow = 0xffff;
static const int gcYellowgreen = 0x32cd9a;
static const System::ShortInt gcNull = -1;
static const System::Byte AdvGraphicsColorCount = 0x9a;
extern PACKAGE System::StaticArray<TAdvGraphicsColorEntry, 154> AdvGraphicsColors;
#define AllSides (System::Set<TAdvGraphicsSide, TAdvGraphicsSide::gsLeft, TAdvGraphicsSide::gsBottom> () << TAdvGraphicsSide::gsLeft << TAdvGraphicsSide::gsTop << TAdvGraphicsSide::gsRight << TAdvGraphicsSide::gsBottom )
extern PACKAGE float Epsilon;
extern PACKAGE Advtypes::TRectF __fastcall ModifyRect(const Advtypes::TRectF &ARect, const TAdvGraphicsModifyRectMode ARectMode);
extern PACKAGE Advtypes::TPointF __fastcall ModifyPoint(const Advtypes::TPointF &APoint, const TAdvGraphicsModifyPointMode APointMode);
extern PACKAGE Classes::TStringList* __fastcall ColorLookup(void);
extern PACKAGE bool __fastcall PolyInRect(TAdvGraphicsPathPolygon APolygon, const Advtypes::TRectF &ARect);
extern PACKAGE bool __fastcall RectInPoly(const Advtypes::TRectF &ARect, TAdvGraphicsPathPolygon APolygon);
extern PACKAGE bool __fastcall PointInPoly(const Advtypes::TPointF &APoint, TAdvGraphicsPathPolygon APolygon);
extern PACKAGE Graphics::TColor __fastcall Blend(Graphics::TColor AColor1, Graphics::TColor AColor2, System::Byte ALevel);
extern PACKAGE Graphics::TColor __fastcall Lighter(Graphics::TColor AColor, System::Byte APercent);
extern PACKAGE Graphics::TColor __fastcall Darker(Graphics::TColor AColor, System::Byte APercent);
extern PACKAGE void __fastcall DrawGradient(Graphics::TCanvas* ACanvas, Graphics::TColor AColor, Graphics::TColor AColorTo, const Types::TRect &ARect, float ARounding, TAdvGraphicsCorners ACorners, bool ADirection);
extern PACKAGE Graphics::TColor __fastcall MakeGraphicsColor(System::Byte ARed, System::Byte AGreen, System::Byte ABlue);

}	/* namespace Advgraphicstypes */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE)
using namespace Advgraphicstypes;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AdvgraphicstypesHPP
