// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AdvPersistence.pas' rev: 22.00

#ifndef AdvpersistenceHPP
#define AdvpersistenceHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Generics.Collections.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <TypInfo.hpp>	// Pascal unit
#include <Variants.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <AdvTypes.hpp>	// Pascal unit
#include <AdvJSONReader.hpp>	// Pascal unit
#include <AdvJSONWriter.hpp>	// Pascal unit
#include <Generics.Defaults.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Advpersistence
{
//-- type declarations -------------------------------------------------------
__interface IAdvPersistence;
typedef System::DelphiInterface<IAdvPersistence> _di_IAdvPersistence;
__interface  INTERFACE_UUID("{363F04AF-B8A7-4C47-A2D6-8ED9C44CEFF6}") IAdvPersistence  : public System::IInterface 
{
	
public:
	virtual void __fastcall SaveSettingsToFile(System::UnicodeString AFileName) = 0 ;
	virtual void __fastcall LoadSettingsFromFile(System::UnicodeString AFileName) = 0 ;
	virtual void __fastcall SaveSettingsToStream(Classes::TStream* AStream) = 0 ;
	virtual void __fastcall LoadSettingsFromStream(Classes::TStream* AStream) = 0 ;
	virtual bool __fastcall CanSaveProperty(System::TObject* AObject, System::UnicodeString APropertyName, Typinfo::TTypeKind APropertyType) = 0 ;
	virtual bool __fastcall CanLoadProperty(System::TObject* AObject, System::UnicodeString APropertyName, Typinfo::TTypeKind APropertyType) = 0 ;
};

class DELPHICLASS EAdvReaderException;
class PASCALIMPLEMENTATION EAdvReaderException : public Sysutils::Exception
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ inline __fastcall EAdvReaderException(const System::UnicodeString Msg) : Sysutils::Exception(Msg) { }
	/* Exception.CreateFmt */ inline __fastcall EAdvReaderException(const System::UnicodeString Msg, System::TVarRec const *Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ inline __fastcall EAdvReaderException(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	/* Exception.CreateResFmt */ inline __fastcall EAdvReaderException(int Ident, System::TVarRec const *Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ inline __fastcall EAdvReaderException(const System::UnicodeString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ inline __fastcall EAdvReaderException(const System::UnicodeString Msg, System::TVarRec const *Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall EAdvReaderException(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall EAdvReaderException(System::PResStringRec ResStringRec, System::TVarRec const *Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	/* Exception.Destroy */ inline __fastcall virtual ~EAdvReaderException(void) { }
	
};


typedef void __fastcall (__closure *TAdvWriteValueProc)(const Advjsonwriter::TAdvJSONWriter* Writer, const System::Variant &Value);

typedef System::Variant __fastcall (__closure *TAdvReadValueProc)(const Advjsonreader::TAdvJSONReader* Reader);

class DELPHICLASS TAdvSerializationInfo;
class PASCALIMPLEMENTATION TAdvSerializationInfo : public System::TObject
{
	typedef System::TObject inherited;
	
protected:
	bool __fastcall IsGenericList(System::TClass AClass);
	bool __fastcall IsCollection(System::TClass AClass);
	bool __fastcall IsList(System::TClass AClass);
	bool __fastcall IsPicture(System::TClass AClass);
	System::TObject* __fastcall CreateObject(const System::UnicodeString AClassName, System::TClass BaseClass);
public:
	/* TObject.Create */ inline __fastcall TAdvSerializationInfo(void) : System::TObject() { }
	/* TObject.Destroy */ inline __fastcall virtual ~TAdvSerializationInfo(void) { }
	
};


typedef Generics_collections::TObjectList__1<System::TObject*>* TAdvObjectList;

typedef System::DynamicArray<System::TObject*> TAdvObjectArray;

class DELPHICLASS TAdvWriter;
class PASCALIMPLEMENTATION TAdvWriter : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	Advjsonwriter::TAdvJSONWriter* FWriter;
	TAdvSerializationInfo* FInfo;
	__property Advjsonwriter::TAdvJSONWriter* Writer = {read=FWriter};
	void __fastcall WritePropInfoValue(System::TObject* Instance, const Typinfo::PPropInfo PropInfo);
	void __fastcall WriteProperties(System::TObject* AObject);
	void __fastcall WriteProperty(System::TObject* AObject, Typinfo::PPropInfo AProp);
	void __fastcall WriteGenericList(Generics_collections::TObjectList__1<System::TObject*>* AList);
	void __fastcall WriteCollection(Classes::TCollection* ACollection);
	void __fastcall WriteBitmap(Graphics::TPicture* ABitmap);
	void __fastcall WriteSingleObject(System::TObject* AObject);
	void __fastcall WriteObject(System::TObject* AObject);
	
public:
	__fastcall TAdvWriter(Classes::TStream* AStream);
	__fastcall virtual ~TAdvWriter(void);
	void __fastcall Write(System::TObject* AObject);
};


class DELPHICLASS TAdvReader;
class PASCALIMPLEMENTATION TAdvReader : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	class DELPHICLASS TAdvObjectReference;
	class PASCALIMPLEMENTATION TAdvObjectReference : public System::TObject
	{
		typedef System::TObject inherited;
		
public:
		System::TObject* Instance;
		Typinfo::TPropInfo *Prop;
		System::UnicodeString Id;
		__fastcall TAdvObjectReference(System::TObject* AInstance, Typinfo::PPropInfo AProp, const System::UnicodeString AId);
public:
		/* TObject.Destroy */ inline __fastcall virtual ~TAdvObjectReference(void) { }
		
	};
	
	
	typedef Generics_collections::TObjectList__1<TAdvObjectReference*>* TAdvObjectReferences;
	
	
private:
	Generics_collections::TObjectList__1<TAdvObjectReference*>* FReferences;
	Advjsonreader::TAdvJSONReader* FReader;
	TAdvSerializationInfo* FInfo;
	System::TObject* __fastcall ReadSingleObject(System::TClass ABaseClass)/* overload */;
	__property Advjsonreader::TAdvJSONReader* Reader = {read=FReader};
	void __fastcall ReadSingleObject(System::TObject* AObject)/* overload */;
	void __fastcall ReadProperties(System::TObject* AObject);
	void __fastcall ReadProperty(System::TObject* AObject, Typinfo::PPropInfo AProp);
	void __fastcall ReadPropInfoValue(System::TObject* Instance, const Typinfo::PPropInfo PropInfo);
	void __fastcall ReadExistingObject(System::TObject* AObject);
	void __fastcall ReadGenericList(Generics_collections::TObjectList__1<System::TObject*>* AList);
	void __fastcall ReadCollection(Classes::TCollection* ACollection);
	void __fastcall ReadBitmap(Graphics::TPicture* ABitmap);
	
public:
	__fastcall TAdvReader(Classes::TStream* AStream);
	__fastcall virtual ~TAdvReader(void);
	System::TObject* __fastcall Read(System::TClass AClass)/* overload */;
	void __fastcall Read(System::TObject* AObject)/* overload */;
};


class DELPHICLASS TAdvPersistence;
class PASCALIMPLEMENTATION TAdvPersistence : public System::TObject
{
	typedef System::TObject inherited;
	
public:
	static System::UnicodeString ClassTypeVariable;
	__classmethod void __fastcall SaveSettingsToFile(System::TObject* AObject, System::UnicodeString AFileName);
	__classmethod void __fastcall LoadSettingsFromFile(System::TObject* AObject, System::UnicodeString AFileName);
	__classmethod void __fastcall SaveSettingsToStream(System::TObject* AObject, Classes::TStream* AStream);
	__classmethod void __fastcall LoadSettingsFromStream(System::TObject* AObject, Classes::TStream* AStream);
public:
	/* TObject.Create */ inline __fastcall TAdvPersistence(void) : System::TObject() { }
	/* TObject.Destroy */ inline __fastcall virtual ~TAdvPersistence(void) { }
	
};


typedef System::StaticArray<System::UnicodeString, 53> Advpersistence__7;

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE Advpersistence__7 ExcludePropertyList;

}	/* namespace Advpersistence */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE)
using namespace Advpersistence;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AdvpersistenceHPP
