// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AdvTreeViewBase.pas' rev: 22.00

#ifndef AdvtreeviewbaseHPP
#define AdvtreeviewbaseHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <AdvTypes.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit
#include <Generics.Defaults.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Advtreeviewbase
{
//-- type declarations -------------------------------------------------------
typedef Graphics::TColor TAdvTreeViewColor;

typedef Graphics::TPicture TAdvTreeViewBitmap;

typedef Graphics::TGraphic TAdvTreeViewIconBitmap;

#pragma option push -b-
enum TAdvTreeViewBrushKind { tvbkNone, tvbkSolid, tvbkGradient };
#pragma option pop

class DELPHICLASS TAdvTreeViewCanvasSaveState;
class DELPHICLASS TAdvTreeViewStrokeBrush;
class DELPHICLASS TAdvTreeViewBrush;
class PASCALIMPLEMENTATION TAdvTreeViewCanvasSaveState : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	TAdvTreeViewStrokeBrush* FStroke;
	TAdvTreeViewBrush* FFill;
	int FSaveDC;
	void __fastcall SetStroke(const TAdvTreeViewStrokeBrush* Value);
	void __fastcall SetFill(const TAdvTreeViewBrush* Value);
	
public:
	__fastcall TAdvTreeViewCanvasSaveState(void);
	__fastcall virtual ~TAdvTreeViewCanvasSaveState(void);
	__property TAdvTreeViewStrokeBrush* Stroke = {read=FStroke, write=SetStroke};
	__property TAdvTreeViewBrush* Fill = {read=FFill, write=SetFill};
	__property int SaveDC = {read=FSaveDC, write=FSaveDC, nodefault};
};


class DELPHICLASS TAdvTreeViewGradient;
class PASCALIMPLEMENTATION TAdvTreeViewGradient : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	Graphics::TColor FColor;
	Graphics::TColor FColorTo;
	Classes::TNotifyEvent FOnChanged;
	void __fastcall SetColor(const Graphics::TColor Value);
	void __fastcall SetColorTo(const Graphics::TColor Value);
	
public:
	__fastcall TAdvTreeViewGradient(void);
	
__published:
	__property Graphics::TColor Color = {read=FColor, write=SetColor, default=16777215};
	__property Graphics::TColor ColorTo = {read=FColorTo, write=SetColorTo, default=12632256};
	__property Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAdvTreeViewGradient(void) { }
	
};


class PASCALIMPLEMENTATION TAdvTreeViewBrush : public Graphics::TBrush
{
	typedef Graphics::TBrush inherited;
	
private:
	Classes::TNotifyEvent FOnChanged;
	TAdvTreeViewGradient* FGradient;
	TAdvTreeViewBrushKind FKind;
	void __fastcall SetGradient(const TAdvTreeViewGradient* Value);
	void __fastcall SetKind(const TAdvTreeViewBrushKind Value);
	
protected:
	void __fastcall GradientChanged(System::TObject* Sender);
	void __fastcall Change(System::TObject* Sender);
	
public:
	__fastcall TAdvTreeViewBrush(TAdvTreeViewBrushKind AKind, Graphics::TColor AColor);
	__fastcall virtual ~TAdvTreeViewBrush(void);
	
__published:
	__property Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
	__property TAdvTreeViewGradient* Gradient = {read=FGradient, write=SetGradient};
	__property TAdvTreeViewBrushKind Kind = {read=FKind, write=SetKind, default=1};
public:
	/* TBrush.Create */ inline __fastcall TAdvTreeViewBrush(void) : Graphics::TBrush() { }
	
};


class PASCALIMPLEMENTATION TAdvTreeViewStrokeBrush : public Graphics::TPen
{
	typedef Graphics::TPen inherited;
	
private:
	Classes::TNotifyEvent FOnChanged;
	
protected:
	void __fastcall Change(System::TObject* Sender);
	
public:
	__fastcall TAdvTreeViewStrokeBrush(TAdvTreeViewBrushKind AKind, Graphics::TColor AColor);
	__property Classes::TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
public:
	/* TPen.Create */ inline __fastcall TAdvTreeViewStrokeBrush(void) : Graphics::TPen() { }
	/* TPen.Destroy */ inline __fastcall virtual ~TAdvTreeViewStrokeBrush(void) { }
	
};


typedef void __fastcall (__closure *TAdvTreeViewBaseControlBeforeDrawEvent)(System::TObject* Sender, Graphics::TCanvas* ACanvas, const Advtypes::TRectF &ARect, bool &ADefaultDraw);

typedef void __fastcall (__closure *TAdvTreeViewBaseControlAfterDrawEvent)(System::TObject* Sender, Graphics::TCanvas* ACanvas, const Advtypes::TRectF &ARect);

class DELPHICLASS TAdvTreeViewBaseControl;
class PASCALIMPLEMENTATION TAdvTreeViewBaseControl : public Controls::TCustomControl
{
	typedef Controls::TCustomControl inherited;
	
private:
	Graphics::TColor FBorderColor;
	void __fastcall SetBorderColor(const Graphics::TColor Value);
	
protected:
	virtual System::UnicodeString __fastcall GetVersion(void);
	virtual System::UnicodeString __fastcall GetDocURL(void);
	virtual System::UnicodeString __fastcall GetTipsURL(void);
	
public:
	virtual void __fastcall BeginUpdate(void);
	virtual void __fastcall EndUpdate(void);
	virtual Advtypes::TRectF __fastcall LocalRect(void);
	virtual Advtypes::TRectF __fastcall GetDrawRect(void);
	virtual void __fastcall Paint(void);
	__fastcall virtual TAdvTreeViewBaseControl(Classes::TComponent* AOwner);
	
__published:
	__property Graphics::TColor BorderColor = {read=FBorderColor, write=SetBorderColor, default=11119017};
public:
	/* TCustomControl.Destroy */ inline __fastcall virtual ~TAdvTreeViewBaseControl(void) { }
	
public:
	/* TWinControl.CreateParented */ inline __fastcall TAdvTreeViewBaseControl(HWND ParentWindow) : Controls::TCustomControl(ParentWindow) { }
	
private:
	void *__IAdvProductInfo;	/* Advtypes::IAdvProductInfo */
	
public:
	#if defined(MANAGED_INTERFACE_OPERATORS)
	operator Advtypes::_di_IAdvProductInfo()
	{
		Advtypes::_di_IAdvProductInfo intf;
		GetInterface(intf);
		return intf;
	}
	#else
	operator Advtypes::IAdvProductInfo*(void) { return (Advtypes::IAdvProductInfo*)&__IAdvProductInfo; }
	#endif
	
};


class DELPHICLASS TAdvTreeViewDoubleListItem;
class DELPHICLASS TAdvTreeViewBase;
class PASCALIMPLEMENTATION TAdvTreeViewDoubleListItem : public Classes::TCollectionItem
{
	typedef Classes::TCollectionItem inherited;
	
private:
	TAdvTreeViewBase* FOwner;
	double FValue;
	int FCellVal;
	void __fastcall SetCellData(const double Value);
	
public:
	__fastcall virtual TAdvTreeViewDoubleListItem(Classes::TCollection* Collection);
	
__published:
	__property double Value = {read=FValue, write=SetCellData};
	__property int CellVal = {read=FCellVal, write=FCellVal, nodefault};
public:
	/* TCollectionItem.Destroy */ inline __fastcall virtual ~TAdvTreeViewDoubleListItem(void) { }
	
};


class DELPHICLASS TAdvTreeViewDoubleList;
class PASCALIMPLEMENTATION TAdvTreeViewDoubleList : public Classes::TCollection
{
	typedef Classes::TCollection inherited;
	
public:
	TAdvTreeViewDoubleListItem* operator[](int Index) { return Items[Index]; }
	
private:
	TAdvTreeViewBase* FOwner;
	Classes::TNotifyEvent FOnChange;
	HIDESBASE TAdvTreeViewDoubleListItem* __fastcall GetItem(int Index);
	HIDESBASE void __fastcall SetItem(int Index, const TAdvTreeViewDoubleListItem* Value);
	
protected:
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	int __fastcall IndexOf(int ACellVal);
	__fastcall TAdvTreeViewDoubleList(TAdvTreeViewBase* AOwner);
	__property TAdvTreeViewDoubleListItem* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
	HIDESBASE TAdvTreeViewDoubleListItem* __fastcall Add(void);
	HIDESBASE TAdvTreeViewDoubleListItem* __fastcall Insert(int Index);
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TAdvTreeViewDoubleList(void) { }
	
};


#pragma option push -b-
enum TAdvTreeViewScrollMode { smPixelScrolling, smNodeScrolling };
#pragma option pop

class PASCALIMPLEMENTATION TAdvTreeViewBase : public TAdvTreeViewBaseControl
{
	typedef TAdvTreeViewBaseControl inherited;
	
private:
	TAdvTreeViewBaseControlAfterDrawEvent FOnAfterDraw;
	TAdvTreeViewBaseControlBeforeDrawEvent FOnBeforeDraw;
	bool FDesignTime;
	float FSaveHScrollPos;
	float FSaveVScrollPos;
	double FTotalRowHeight;
	bool FNodeListBuild;
	double FTotalColumnWidth;
	double FStartOffset;
	int FStartCol;
	int FStopCol;
	int FStartRow;
	int FStopRow;
	double FStartX;
	double FStopX;
	double FStartY;
	double FStopY;
	bool FBlockScrollingUpdate;
	int FUpdateCount;
	Stdctrls::TScrollBar* FVerticalScrollBar;
	Stdctrls::TScrollBar* FHorizontalScrollBar;
	int FRowCount;
	int FColumnCount;
	TAdvTreeViewDoubleList* FColumnW;
	TAdvTreeViewDoubleList* FColumnP;
	double FDefaultRowHeight;
	double FDefaultColumnWidth;
	bool FVerticalScrollBarVisible;
	bool FHorizontalScrollBarVisible;
	TAdvTreeViewScrollMode FScrollMode;
	bool FIsMouseDown;
	bool FDelayedLoading;
	bool FStretchScrollBars;
	bool FBlockUpdateNodeList;
	bool FBlockUpdateNode;
	int FBlockRemoveNode;
	void __fastcall SetColumnCount(const int Value);
	void __fastcall SetRowCount(const int Value);
	void __fastcall SetDefaultColumnWidth(const double Value);
	void __fastcall SetDefaultRowHeight(const double Value);
	void __fastcall SetHorizontalScrollBarVisible(const bool Value);
	void __fastcall SetVerticalScrollBarVisible(const bool Value);
	void __fastcall SetScrollMode(const TAdvTreeViewScrollMode Value);
	void __fastcall SetColWidths(int Col, const double Value);
	void __fastcall SetColumnP(const TAdvTreeViewDoubleList* Value);
	void __fastcall SetColumnW(const TAdvTreeViewDoubleList* Value);
	double __fastcall GetColWidths(int Col);
	double __fastcall GetColPos(int Col);
	void __fastcall SetColPos(int Col, const double Value);
	void __fastcall SetStretchScrollBars(const bool Value);
	
protected:
	HIDESBASE virtual System::UnicodeString __fastcall GetVersionNumber(System::ShortInt AMaj, System::ShortInt AMin, System::ShortInt ARel, System::ShortInt ABld);
	virtual void __fastcall UpdateTreeView(void);
	virtual void __fastcall UpdateColumns(void) = 0 ;
	virtual void __fastcall AutoSizeColumnInternal(int ACol, bool AUpdate = false, bool ACallEventHandlers = false) = 0 ;
	virtual void __fastcall UpdateVisualRange(void);
	virtual void __fastcall StretchColumn(bool AStretchAll = true, int ACol = 0xffffffff, double ANewWidth = -1.000000E+00);
	virtual void __fastcall StopAnimationTimer(void) = 0 ;
	void __fastcall Scroll(double AHorizontalPos, double AVerticalPos);
	virtual void __fastcall UpdateDisplay(void);
	virtual void __fastcall VerticalScrollPositionChanged(void) = 0 ;
	virtual void __fastcall HorizontalScrollPositionChanged(void) = 0 ;
	void __fastcall VScrollChanged(System::TObject* Sender);
	void __fastcall HScrollChanged(System::TObject* Sender);
	virtual void __fastcall UpdateAutoSizing(void) = 0 ;
	virtual void __fastcall UpdateColumnRowCalculations(bool AUpdateTotalRowHeight = true) = 0 ;
	void __fastcall UpdateScrollBars(bool AUpdate = true, bool ACalculate = true);
	virtual void __fastcall UpdateCalculations(void) = 0 ;
	virtual void __fastcall ResetNodes(bool AUpdateAll = true) = 0 ;
	virtual void __fastcall UpdateColumnsCache(void) = 0 ;
	virtual void __fastcall UpdateGroupsCache(void) = 0 ;
	virtual void __fastcall UpdateNodesCache(bool AUpdateNodes = true, bool AResetNodes = false) = 0 ;
	virtual void __fastcall UpdateTreeViewCache(void);
	virtual void __fastcall UpdateTreeViewDisplay(void);
	virtual void __fastcall Loaded(void);
	virtual void __fastcall SetHScrollValue(float AValue);
	virtual void __fastcall SetVScrollValue(float AValue);
	virtual bool __fastcall IsColumnVisible(int ACol);
	virtual double __fastcall GetRowHeight(int ARow);
	virtual Advtypes::TRectF __fastcall GetCalculationRect(void);
	virtual Advtypes::TRectF __fastcall GetContentRect(void);
	virtual Advtypes::TRectF __fastcall GetContentClipRect(void);
	virtual float __fastcall GetHScrollValue(void);
	virtual float __fastcall GetVScrollValue(void);
	virtual float __fastcall GetVViewPortSize(void);
	virtual float __fastcall GetHViewPortSize(void);
	virtual double __fastcall GetColumnViewPortSize(void);
	virtual double __fastcall GetRowViewPortSize(void);
	__property double TotalColumnWidth = {read=FTotalColumnWidth, write=FTotalColumnWidth};
	__property double TotalRowHeight = {read=FTotalRowHeight, write=FTotalRowHeight};
	__property bool IsMouseDown = {read=FIsMouseDown, write=FIsMouseDown, nodefault};
	__property double DefaultRowHeight = {read=FDefaultRowHeight, write=SetDefaultRowHeight};
	__property double DefaultColumnWidth = {read=FDefaultColumnWidth, write=SetDefaultColumnWidth};
	__property bool HorizontalScrollBarVisible = {read=FHorizontalScrollBarVisible, write=SetHorizontalScrollBarVisible, default=1};
	__property bool VerticalScrollBarVisible = {read=FVerticalScrollBarVisible, write=SetVerticalScrollBarVisible, default=1};
	__property int RowCount = {read=FRowCount, write=SetRowCount, nodefault};
	__property int ColumnCount = {read=FColumnCount, write=SetColumnCount, nodefault};
	__property TAdvTreeViewScrollMode ScrollMode = {read=FScrollMode, write=SetScrollMode, default=0};
	__property double ColumnPositions[int Col] = {read=GetColPos, write=SetColPos};
	__property double ColumnWidths[int Col] = {read=GetColWidths, write=SetColWidths};
	__property TAdvTreeViewDoubleList* ColumnW = {read=FColumnW, write=SetColumnW};
	__property TAdvTreeViewDoubleList* ColumnP = {read=FColumnP, write=SetColumnP};
	__property int UpdateCount = {read=FUpdateCount, write=FUpdateCount, nodefault};
	__property bool BlockScrollingUpdate = {read=FBlockScrollingUpdate, write=FBlockScrollingUpdate, nodefault};
	__property bool StretchScrollBars = {read=FStretchScrollBars, write=SetStretchScrollBars, default=1};
	__property bool BlockUpdateNodeList = {read=FBlockUpdateNodeList, write=FBlockUpdateNodeList, nodefault};
	__property bool BlockUpdateNode = {read=FBlockUpdateNode, write=FBlockUpdateNode, nodefault};
	__property bool NodeListBuild = {read=FNodeListBuild, write=FNodeListBuild, nodefault};
	__property int BlockRemoveNode = {read=FBlockRemoveNode, write=FBlockRemoveNode, nodefault};
	
public:
	__fastcall virtual TAdvTreeViewBase(Classes::TComponent* AOwner);
	__fastcall virtual ~TAdvTreeViewBase(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	DYNAMIC void __fastcall Resize(void);
	virtual void __fastcall BeginUpdate(void);
	virtual void __fastcall EndUpdate(void);
	virtual void __fastcall Paint(void);
	virtual void __fastcall SaveScrollPosition(void);
	virtual void __fastcall RestoreScrollPosition(void);
	virtual void __fastcall AutoSizeColumn(int ACol);
	virtual bool __fastcall IsDesignTime(void);
	virtual double __fastcall GetVerticalScrollPosition(void);
	virtual double __fastcall GetHorizontalScrollPosition(void);
	Stdctrls::TScrollBar* __fastcall HorizontalScrollBar(void);
	Stdctrls::TScrollBar* __fastcall VerticalScrollBar(void);
	int __fastcall StartCol(void);
	int __fastcall StopCol(void);
	double __fastcall StartX(void);
	double __fastcall StopX(void);
	int __fastcall StartRow(void);
	double __fastcall StartOffset(void);
	int __fastcall StopRow(void);
	double __fastcall StartY(void);
	double __fastcall StopY(void);
	double __fastcall GetTotalColumnWidth(void);
	double __fastcall GetTotalRowHeight(void);
	
__published:
	__property TAdvTreeViewBaseControlBeforeDrawEvent OnBeforeDraw = {read=FOnBeforeDraw, write=FOnBeforeDraw};
	__property TAdvTreeViewBaseControlAfterDrawEvent OnAfterDraw = {read=FOnAfterDraw, write=FOnAfterDraw};
public:
	/* TWinControl.CreateParented */ inline __fastcall TAdvTreeViewBase(HWND ParentWindow) : TAdvTreeViewBaseControl(ParentWindow) { }
	
};


//-- var, const, procedure ---------------------------------------------------
static const System::Word SWIPECOUNT = 0x12c;
static const System::ShortInt DOWNCOUNT = 0xf;
static const int TAdvTreeViewColorBlack = 0;
static const int TAdvTreeViewColorGray = 8421504;
static const int TAdvTreeViewColorDarkGray = 0xa9a9a9;
static const int TAdvTreeViewColorExtended = 0xf4f4f4;
static const int TAdvTreeViewColorSilver = 12632256;
static const int TAdvTreeViewColorNull = 536870911;
static const int TAdvTreeViewColorSelection = 0xf8ad1b;
static const int TAdvTreeViewColorWhite = 16777215;

}	/* namespace Advtreeviewbase */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE)
using namespace Advtreeviewbase;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AdvtreeviewbaseHPP
