// CodeGear C++Builder
// Copyright (c) 1995, 2010 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'AdvTypes.pas' rev: 22.00

#ifndef AdvtypesHPP
#define AdvtypesHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Types.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Advtypes
{
//-- type declarations -------------------------------------------------------
__interface IAdvProductInfo;
typedef System::DelphiInterface<IAdvProductInfo> _di_IAdvProductInfo;
__interface  INTERFACE_UUID("{C53329EA-7B3A-4507-AD9E-88ACD6A85054}") IAdvProductInfo  : public System::IInterface 
{
	
public:
	virtual System::UnicodeString __fastcall GetVersion(void) = 0 ;
	virtual System::UnicodeString __fastcall GetDocURL(void) = 0 ;
	virtual System::UnicodeString __fastcall GetTipsURL(void) = 0 ;
};

typedef Controls::TMouseButton TAdvMouseButton;

struct TSizeF;
typedef TSizeF *PSizeF;

struct DECLSPEC_DRECORD TSizeF
{
	
public:
	float cx;
	float cy;
	__property float Width = {read=cx, write=cx};
	__property float Height = {read=cy, write=cy};
};


typedef System::StaticArray<float, 2> TPointFType;

struct TPointF;
typedef TPointF *PPointF;

struct DECLSPEC_DRECORD TPointF
{
	
public:
	float __fastcall Length(void);
	void __fastcall Offset(const float ADeltaX, const float ADeltaY);
	#pragma pack(push,1)
	union
	{
		struct 
		{
			float X;
			float Y;
			
		};
		struct 
		{
			TPointFType V;
			
		};
		
	};
	#pragma pack(pop)
};


struct TRectF;
typedef TRectF *PRectF;

struct DECLSPEC_DRECORD TRectF
{
	
private:
	float __fastcall GetWidth(void);
	void __fastcall SetWidth(const float Value);
	float __fastcall GetHeight(void);
	void __fastcall SetHeight(const float Value);
	TSizeF __fastcall GetSize(void);
	void __fastcall SetSize(const TSizeF &Value);
	
public:
	void __fastcall Offset(const float DX, const float DY);
	void __fastcall Inflate(const float DX, const float DY);
	TRectF __fastcall CenterAt(const TRectF &ADesignatedArea);
	TRectF __fastcall SnapToPixel(const float AScale, const bool APlaceBetweenPixels);
	TRectF __fastcall FitInto(const TRectF &ADesignatedArea, /* out */ float &Ratio)/* overload */;
	TRectF __fastcall FitInto(const TRectF &ADesignatedArea)/* overload */;
	bool __fastcall IsEmpty(void);
	bool __fastcall IntersectsWith(const TRectF &R);
	TPointF __fastcall CenterPoint(void);
	TRectF __fastcall Empty(void);
	__property float Width = {read=GetWidth, write=SetWidth};
	__property float Height = {read=GetHeight, write=SetHeight};
	__property TSizeF Size = {read=GetSize, write=SetSize};
	#pragma pack(push,1)
	union
	{
		struct 
		{
			TPointF TopLeft;
			TPointF BottomRight;
			
		};
		struct 
		{
			float Left;
			float Top;
			float Right;
			float Bottom;
			
		};
		
	};
	#pragma pack(pop)
};


typedef Graphics::TPicture TAdvBitmap;

typedef Graphics::TGraphic TAdvDrawBitmap;

typedef void *TAdvBitmapHelper;

class DELPHICLASS TAdvMargins;
class PASCALIMPLEMENTATION TAdvMargins : public Classes::TPersistent
{
	typedef Classes::TPersistent inherited;
	
private:
	float FRight;
	float FBottom;
	float FTop;
	float FLeft;
	Classes::TNotifyEvent FOnChange;
	void __fastcall SetBottom(const float Value);
	void __fastcall SetLeft(const float Value);
	void __fastcall SetRight(const float Value);
	void __fastcall SetTop(const float Value);
	bool __fastcall IsLeftStored(void);
	bool __fastcall IsTopStored(void);
	bool __fastcall IsRightStored(void);
	bool __fastcall IsBottomStored(void);
	
protected:
	void __fastcall Changed(void);
	
public:
	__fastcall TAdvMargins(void)/* overload */;
	__fastcall TAdvMargins(const TRectF &ARect)/* overload */;
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	bool __fastcall Empty(void);
	TRectF __fastcall Rect(void);
	TRectF __fastcall PaddingRect(const TRectF &R);
	
__published:
	__property float Left = {read=FLeft, write=SetLeft, stored=IsLeftStored};
	__property float Top = {read=FTop, write=SetTop, stored=IsTopStored};
	__property float Right = {read=FRight, write=SetRight, stored=IsRightStored};
	__property float Bottom = {read=FBottom, write=SetBottom, stored=IsBottomStored};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
public:
	/* TPersistent.Destroy */ inline __fastcall virtual ~TAdvMargins(void) { }
	
};


class DELPHICLASS TAdvScaledBitmap;
class PASCALIMPLEMENTATION TAdvScaledBitmap : public Classes::TCollectionItem
{
	typedef Classes::TCollectionItem inherited;
	
private:
	Graphics::TPicture* FBitmap;
	float FScale;
	System::UnicodeString FBitmapName;
	bool __fastcall IsScaleStored(void);
	void __fastcall SetBitmap(const Graphics::TPicture* Value);
	void __fastcall SetScale(const float Value);
	void __fastcall SetBitmapName(const System::UnicodeString Value);
	
protected:
	void __fastcall BitmapChanged(System::TObject* Sender);
	
public:
	__fastcall virtual TAdvScaledBitmap(Classes::TCollection* Collection);
	__fastcall virtual ~TAdvScaledBitmap(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Graphics::TPicture* Bitmap = {read=FBitmap, write=SetBitmap};
	__property System::UnicodeString BitmapName = {read=FBitmapName, write=SetBitmapName};
	__property float Scale = {read=FScale, write=SetScale, stored=IsScaleStored};
};


class DELPHICLASS TAdvScaledBitmaps;
class PASCALIMPLEMENTATION TAdvScaledBitmaps : public Classes::TOwnedCollection
{
	typedef Classes::TOwnedCollection inherited;
	
public:
	TAdvScaledBitmap* operator[](int Index) { return Items[Index]; }
	
private:
	Classes::TNotifyEvent FOnChange;
	TAdvScaledBitmap* __fastcall GetItems(int Index);
	void __fastcall SetItems(int Index, const TAdvScaledBitmap* Value);
	Graphics::TPicture* __fastcall GetBitmap(float Scale);
	void __fastcall SetBitmap(float Scale, const Graphics::TPicture* Value);
	
protected:
	virtual void __fastcall Update(Classes::TCollectionItem* Item);
	
public:
	__fastcall TAdvScaledBitmaps(Classes::TComponent* AOwner);
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	HIDESBASE TAdvScaledBitmap* __fastcall Add(float Scale = 1.000000E+00)/* overload */;
	TAdvScaledBitmap* __fastcall AddBitmapFromFile(System::UnicodeString FileName, float Scale = 1.000000E+00);
	TAdvScaledBitmap* __fastcall AddBitmapFromResource(System::UnicodeString ResourceName, float Scale = 1.000000E+00)/* overload */;
	TAdvScaledBitmap* __fastcall AddBitmapFromResource(System::UnicodeString ResourceName, unsigned AInstance, float Scale = 1.000000E+00)/* overload */;
	TAdvScaledBitmap* __fastcall AddBitmap(Graphics::TPicture* Bitmap, float Scale = 1.000000E+00);
	TAdvScaledBitmap* __fastcall AddBitmapName(System::UnicodeString BitmapName, float Scale = 1.000000E+00);
	TAdvScaledBitmap* __fastcall AddDrawBitmap(Graphics::TGraphic* Bitmap, float Scale = 1.000000E+00);
	HIDESBASE TAdvScaledBitmap* __fastcall Insert(int Index)/* overload */;
	HIDESBASE TAdvScaledBitmap* __fastcall Insert(int Index, float Scale)/* overload */;
	Graphics::TPicture* __fastcall GetBitmapByScale(float Scale);
	TAdvScaledBitmap* __fastcall GetItemByScale(float Scale);
	__property TAdvScaledBitmap* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
	__property Graphics::TPicture* Bitmaps[float Scale] = {read=GetBitmap, write=SetBitmap};
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TAdvScaledBitmaps(void) { }
	
};


#pragma option push -b-
enum TAdvPictureFormat { pfBMP, pfGIF, pfJPG, pfPNG, pfICO, pfTiff, pfMetaFile, pfNone };
#pragma option pop

__interface IAdvCustomEditor;
typedef System::DelphiInterface<IAdvCustomEditor> _di_IAdvCustomEditor;
__interface  INTERFACE_UUID("{CC0C60B7-75F3-47CE-8A7F-8005A19F12E8}") IAdvCustomEditor  : public System::IInterface 
{
	
public:
	virtual void __fastcall SetText(System::UnicodeString AValue) = 0 ;
	virtual void __fastcall SetSelStart(int AValue) = 0 ;
	virtual void __fastcall SetSelLength(int AValue) = 0 ;
	virtual int __fastcall GetTextLength(void) = 0 ;
};

template<typename T> class DELPHICLASS TAdvOwnedCollection__1;
// Template declaration generated by Delphi parameterized types is
// used only for accessing Delphi variables and fields.
// Don't instantiate with new type parameters in user code.
template<typename T> class PASCALIMPLEMENTATION TAdvOwnedCollection__1 : public Classes::TOwnedCollection
{
	typedef Classes::TOwnedCollection inherited;
	
public:
	class DELPHICLASS TEnumerator;
	// Template declaration generated by Delphi parameterized types is
	// used only for accessing Delphi variables and fields.
	// Don't instantiate with new type parameters in user code.
	class PASCALIMPLEMENTATION TEnumerator : public System::TObject
	{
		typedef System::TObject inherited;
		
private:
		int FIndex;
		TAdvOwnedCollection__1<T>* FCol;
		
public:
		__fastcall TEnumerator(TAdvOwnedCollection__1<T>* ACol);
		T __fastcall GetCurrent(void);
		bool __fastcall MoveNext(void);
		__property T Current = {read=GetCurrent};
public:
		/* TObject.Destroy */ inline __fastcall virtual ~TEnumerator(void) { }
		
	};
	
	
	
public:
	HIDESBASE TEnumerator* __fastcall GetEnumerator(void);
	HIDESBASE T __fastcall GetItem(int AIndex);
public:
	/* TOwnedCollection.Create */ inline __fastcall TAdvOwnedCollection__1(Classes::TPersistent* AOwner, Classes::TCollectionItemClass ItemClass) : Classes::TOwnedCollection(AOwner, ItemClass) { }
	
public:
	/* TCollection.Destroy */ inline __fastcall virtual ~TAdvOwnedCollection__1(void) { }
	
};


typedef Types::TValueRelationship TAdvValueRelationShip;

//-- var, const, procedure ---------------------------------------------------
#define TAdvBaseDocURL L"http://www.tmssoftware.biz/Download/Manuals/TMS%20Componen"\
	L"t%20Pack%20Quick%20Start.pdf"
#define TAdvBaseTipsURL L"http://www.tmssoftware.com/site/tmspack.asp?s=faq"
static const System::Word pidWeb = 0x1000;
static const Classes::Classes__1 ssCommand = (Classes::Classes__1)(2);
static const System::ShortInt TMSPlatformsDesktop = 0x0;
static const System::ShortInt TMSPlatforms = 0x0;
static const System::ShortInt TMSPlatformsWeb = 0x0;
static const System::ShortInt TMSPlatformsWebDesktop = 0x0;
static const System::ShortInt KEY_CANCEL = 0x3;
static const System::ShortInt KEY_CONTROL = 0x11;
static const System::ShortInt KEY_SHIFT = 0x10;
static const System::ShortInt KEY_ESCAPE = 0x1b;
static const System::ShortInt KEY_INSERT = 0x2d;
static const System::ShortInt KEY_DELETE = 0x2e;
static const System::ShortInt KEY_TAB = 0x9;
static const System::ShortInt KEY_PRIOR = 0x21;
static const System::ShortInt KEY_NEXT = 0x22;
static const System::ShortInt KEY_UP = 0x26;
static const System::ShortInt KEY_DOWN = 0x28;
static const System::ShortInt KEY_RIGHT = 0x27;
static const System::ShortInt KEY_LEFT = 0x25;
static const System::ShortInt KEY_HOME = 0x24;
static const System::ShortInt KEY_END = 0x23;
static const System::ShortInt KEY_RETURN = 0xd;
static const System::ShortInt KEY_SPACE = 0x20;
static const System::ShortInt KEY_MENU = 0x12;
static const System::ShortInt KEY_BACK = 0x8;
static const System::ShortInt KEY_F1 = 0x70;
static const System::ShortInt KEY_F2 = 0x71;
static const System::ShortInt KEY_F3 = 0x72;
static const System::ShortInt KEY_F4 = 0x73;
static const System::ShortInt KEY_F5 = 0x74;
static const System::ShortInt KEY_F6 = 0x75;
static const System::ShortInt KEY_F7 = 0x76;
static const System::ShortInt KEY_F8 = 0x77;
static const System::ShortInt KEY_F9 = 0x78;
static const System::ShortInt KEY_F10 = 0x79;
static const System::ShortInt KEY_F11 = 0x7a;
static const System::ShortInt KEY_F12 = 0x7b;
extern PACKAGE bool __fastcall CharIsHex(System::WideChar AChar);
extern PACKAGE bool __fastcall CharIsLetter(System::WideChar AChar);
extern PACKAGE bool __fastcall CharIsNumber(System::WideChar AChar);
extern PACKAGE bool __fastcall CharIsLetterOrNumber(System::WideChar AChar);
extern PACKAGE bool __fastcall CharInArray(System::WideChar AChar, System::WideChar *ACharArray, const int ACharArray_Size);
extern PACKAGE bool __fastcall IsBitmapEmpty(Graphics::TPicture* ABitmap);
extern PACKAGE Graphics::TGraphic* __fastcall BitmapToDrawBitmap(Graphics::TPicture* ABitmap)/* overload */;
extern PACKAGE bool __fastcall PtInRectEx(const TRectF &Rect, const TPointF &P);
extern PACKAGE TPointF __fastcall PointF(float X, float Y)/* overload */;
extern PACKAGE bool __fastcall OffsetRectEx(Types::TRect &R, int DX, int DY)/* overload */;
extern PACKAGE bool __fastcall OffsetRectEx(TRectF &R, float DX, float DY)/* overload */;
extern PACKAGE TRectF __fastcall RectF(float Left, float Top, float Right, float Bottom)/* overload */;
extern PACKAGE void __fastcall InflateRectEx(TRectF &R, float DX, float DY);
extern PACKAGE bool __fastcall IntersectRectEx(const TRectF &Rect1, const TRectF &Rect2)/* overload */;
extern PACKAGE bool __fastcall EqualRectEx(const Types::TRect &R1, const Types::TRect &R2)/* overload */;
extern PACKAGE bool __fastcall EqualRectEx(const TRectF &R1, const TRectF &R2)/* overload */;
extern PACKAGE int __fastcall RectWidthEx(const Types::TRect &Rect)/* overload */;
extern PACKAGE int __fastcall RectHeightEx(const Types::TRect &Rect)/* overload */;
extern PACKAGE float __fastcall RectWidthEx(const TRectF &Rect)/* overload */;
extern PACKAGE float __fastcall RectHeightEx(const TRectF &Rect)/* overload */;
extern PACKAGE TRectF __fastcall RectCenterAtEx(const TRectF &Rect, const TRectF &ADesignatedArea);
extern PACKAGE TRectF __fastcall RectSnapToPixelEx(const TRectF &Rect, const float AScale, const bool APlaceBetweenPixels);
extern PACKAGE TRectF __fastcall RectFitIntoEx(const TRectF &Rect, const TRectF &ADesignatedArea, /* out */ float &Ratio)/* overload */;
extern PACKAGE TRectF __fastcall RectFitIntoEx(const TRectF &Rect, const TRectF &ADesignatedArea)/* overload */;
extern PACKAGE Types::TRect __fastcall RectCenterEx(Types::TRect &R, const Types::TRect &B)/* overload */;
extern PACKAGE TRectF __fastcall RectCenterEx(TRectF &R, const TRectF &B)/* overload */;
extern PACKAGE bool __fastcall IntersectRectEx(/* out */ TRectF &Rect, const TRectF &R1, const TRectF &R2)/* overload */;
extern PACKAGE TRectF __fastcall EmptyRect(void);
extern PACKAGE bool __fastcall RectIsEmpty(const TRectF &R);
extern PACKAGE Types::TValueRelationship __fastcall CompareValueEx(const System::Extended A, const System::Extended B, System::Extended Epsilon = 0.000000E+00);
extern PACKAGE bool __fastcall RectIntersectsWithEx(const TRectF &ARect, const TRectF &R);
extern PACKAGE TPointF __fastcall CenterPointEx(const TRectF &R);
extern PACKAGE TRectF __fastcall MakeRectF(float Left, float Top, float Width, float Height);
extern PACKAGE float __fastcall GetPointLength(const TPointF &Point);
extern PACKAGE Types::TRect __fastcall ConvertToRect(const Types::TRect &Rect)/* overload */;
extern PACKAGE Types::TRect __fastcall ConvertToRect(const TRectF &Rect)/* overload */;
extern PACKAGE TRectF __fastcall ConvertToRectF(const TRectF &Rect)/* overload */;
extern PACKAGE TRectF __fastcall ConvertToRectF(const Types::TRect &Rect)/* overload */;
extern PACKAGE Types::TPoint __fastcall ConvertToPoint(const Types::TPoint &Point)/* overload */;
extern PACKAGE Types::TPoint __fastcall ConvertToPoint(const TPointF &Point)/* overload */;
extern PACKAGE TPointF __fastcall ConvertToPointF(const TPointF &Point)/* overload */;
extern PACKAGE TPointF __fastcall ConvertToPointF(const Types::TPoint &Point)/* overload */;
extern PACKAGE tagSIZE __fastcall ConvertToSize(const tagSIZE &Size)/* overload */;
extern PACKAGE tagSIZE __fastcall ConvertToSize(const TSizeF &Size)/* overload */;
extern PACKAGE TSizeF __fastcall ConvertToSizeF(const TSizeF &Size)/* overload */;
extern PACKAGE TSizeF __fastcall ConvertToSizeF(const tagSIZE &Size)/* overload */;

}	/* namespace Advtypes */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE)
using namespace Advtypes;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// AdvtypesHPP
